unit UfrmCalculate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Placemnt, OvcBase, OvcState;

type
  TfrmCalculate = class(TForm)
    btnPlus: TButton;
    btnMin: TButton;
    Edit1: TEdit;
    btnDiv: TButton;
    btnMaal: TButton;
    Button5: TButton;
    Button6: TButton;
    btn1: TButton;
    btn4: TButton;
    btn7: TButton;
    btn2: TButton;
    btn3: TButton;
    btn5: TButton;
    btn9: TButton;
    btn8: TButton;
    btn6: TButton;
    btn0: TButton;
    btnPoint: TButton;
    btnIs: TButton;
    OvcFormState1: TOvcFormState;
    procedure btn1Click(Sender: TObject);
    procedure btnPlusClick(Sender: TObject);
    procedure btnMinClick(Sender: TObject);
    procedure btnDivClick(Sender: TObject);
    procedure btnMaalClick(Sender: TObject);
    procedure btnIsClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure btnPointClick(Sender: TObject);
  private
    FValue, FLastValue: single;
    FNextValue: boolean;
    FLastComputing: integer;
    { Private declarations }
    procedure SetValue(value: single);
    procedure DoLastComputing;
  public
    property Value: single read FValue write SetValue;
    { Public declarations }
  end;

var
  frmCalculate: TfrmCalculate;

implementation

uses
  UfrmMain;

{$R *.DFM}

procedure TfrmCalculate.SetValue(value: single);
begin
  FNextValue := True;
  FLastComputing := 0; //none
  Edit1.Text := Format('%5.0f', [value]);
  FValue := StrToFloat(Edit1.Text);
end;

procedure TfrmCalculate.btn1Click(Sender: TObject);
begin
  if FNextValue then Edit1.Text := '';
  Edit1.Text := Edit1.Text + IntToStr(TButton(Sender).tag);
  FNextValue := False;
end;

procedure TfrmCalculate.DoLastComputing;
begin
  if FLastComputing > 0 then
  begin
    FValue := StrToFloat(Edit1.Text);
    case FLastComputing of
      1: FValue := FLastValue + FValue;
      2: FValue := FLastValue - FValue;
      3: FValue := FLastValue / FValue;
      4: FValue := FLastValue * FValue;
    end;
    Edit1.Text := Format('%5.0f', [value]);
  end;
end;

procedure TfrmCalculate.btnPlusClick(Sender: TObject);
begin
  DoLastComputing;
  FLastValue := StrToFloat(Edit1.Text);
  FNextValue := True;
  FLastComputing := 1;
end;

procedure TfrmCalculate.btnMinClick(Sender: TObject);
begin
  DoLastComputing;
  FLastValue := StrToFloat(Edit1.Text);
  FNextValue := True;
  FLastComputing := 2;
end;

procedure TfrmCalculate.btnDivClick(Sender: TObject);
begin
  DoLastComputing;
  FLastValue := StrToFloat(Edit1.Text);
  FNextValue := True;
  FLastComputing := 3;
end;

procedure TfrmCalculate.btnMaalClick(Sender: TObject);
begin
  DoLastComputing;
  FLastValue := StrToFloat(Edit1.Text);
  FNextValue := True;
  FLastComputing := 4;
end;

procedure TfrmCalculate.btnIsClick(Sender: TObject);
begin
  DoLastComputing;
  FLastValue := StrToFloat(Edit1.Text);
  FNextValue := True;
  FLastComputing := 0;
end;

procedure TfrmCalculate.Button6Click(Sender: TObject);
begin
  DoLastComputing;
end;

procedure TfrmCalculate.btnPointClick(Sender: TObject);
begin
  if FNextValue then Edit1.Text := '';
  Edit1.Text := Edit1.Text + '.';
  FNextValue := False;
end;

end.
