unit UfrmIncomingGroups;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, EnhListView, ExtListView, OvcBase, OvcState;

type
  TfrmIncomingGroups = class(TForm)
    PopupMenu1: TPopupMenu;
    lvIncomingGroups: TdfsExtListView;
    OvcFormState1: TOvcFormState;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure lvIncomingGroups2Click(Sender: TObject);
    procedure lvIncomingGroups2DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure FillLvIncomingGroups;
    { Public declarations }
  end;

var
  frmIncomingGroups: TfrmIncomingGroups;

implementation

{$R *.DFM}

uses
  HyperStr, UTypes, UfrmPlanets, UfrmMain;

procedure TfrmIncomingGroups.FillLvIncomingGroups;
var
  newListItem: TListItem;
  IncomingGroup: TIncomingGroup;
  i: integer;
begin
  for i := 0 to IncomingGroups.Count - 1 do
  begin
    IncomingGroup := TIncomingGroup(IncomingGroups.Items[i]);
    newListItem := LvIncomingGroups.Items.Add;
    newListItem.Caption := USIToStr(IncomingGroup.Turn);
    newListItem.SubItems.AddObject(IncomingGroup.FromPlanet.Name, IncomingGroup.FromPlanet);
    newListItem.SubItems.AddObject(IncomingGroup.DestPlanet.Name, IncomingGroup.DestPlanet);
    newListItem.SubItems.Add(Format('%5.2f', [IncomingGroup.range]));
    newListItem.SubItems.Add(Format('%5.2f', [IncomingGroup.speed]));
    newListItem.SubItems.Add(Format('%5.2f', [IncomingGroup.mass]));
    newListItem.Data := IncomingGroup;
  end;
end;

procedure TfrmIncomingGroups.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmIncomingGroups.FormShow(Sender: TObject);
begin
  FillLvIncomingGroups;
end;

procedure TfrmIncomingGroups.lvIncomingGroups2Click(Sender: TObject);
begin
  if Assigned(lvIncomingGroups.Selected) then
    frmPlanets.ShowPlanet(TIncomingGroup(lvIncomingGroups.Selected.Data).FromPlanet, true);
end;

procedure TfrmIncomingGroups.lvIncomingGroups2DblClick(Sender: TObject);
begin
  if Assigned(lvIncomingGroups.Selected) then
    frmPlanets.ShowPlanet(TIncomingGroup(lvIncomingGroups.Selected.Data).DestPlanet, true);
end;

end.
