unit UfrmOrders;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RXCtrls, ComCtrls, ExtCtrls, Menus, Email, UTypes,
  EnhListView, ExtListView, ImgList, OvcBase, OvcState, EC_LView,
  EC_ExtLView, EC_Main, UfrmAutoCargoSettings, mwHighlighter, mwCustomEdit,
  mkGalaxySyn;

resourcestring
  SNONE = '(none)';
  STxtMesSaved = 'Text is Saved';
  StitMesSaved = 'Saved';
  SMAPILoFailed = 'MAPI Logon failed.';
  SMAPILfFailed = 'MAPI Logoff failed.';
  SMAPISmFailed = 'MAPI Sendmail failed - Error %d';
  SMAPISvFailed = 'MAPI Savemail failed - Error %d';
type
  TfrmOrders = class(TForm)
    pnlPlanets: TPanel;
    Splitter1: TSplitter;
    pnlOrders: TPanel;
    Splitter2: TSplitter;
    pnlShips: TPanel;
    Panel1: TPanel;
    PageControl1: TPageControl;
    tshDeveloping: TTabSheet;
    tshToTransport: TTabSheet;
    PageControl2: TPageControl;
    tshToDo: TTabSheet;
    tshLoadedSend: TTabSheet;
    MainMenu1: TMainMenu;
    mniView: TMenuItem;
    mniStayOnTop: TMenuItem;
    mniMailSettings: TMenuItem;
    mniHide: TMenuItem;
    mniGalaxyServeradress: TMenuItem;
    mniSubject: TMenuItem;
    Email: TEmail;
    PopupMenu1: TPopupMenu;
    mniMailorders: TMenuItem;
    mniSaveorders: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    mniLoadorders: TMenuItem;
    mniPlaceinOutbox: TMenuItem;
    Panel2: TPanel;
    btnAnalyse: TButton;
    tshSendedShips: TTabSheet;
    tshToDevelop: TTabSheet;
    lvSendedShips: TdfsExtListView;
    popupToDo: TPopupMenu;
    ViewPlanet1: TMenuItem;
    LoadCOLSendto1: TMenuItem;
    LoadCAPSendto1: TMenuItem;
    Sendto1: TMenuItem;
    imlDistanceLeft: TImageList;
    lvLoadedSend: TdfsExtListView;
    lvToDo: TdfsExtListView;
    lvToDevelop: TdfsExtListView;
    lvToTransport: TdfsExtListView;
    lvDeveloping: TdfsExtListView;
    mniOptions: TMenuItem;
    mniAutoInsertCommands: TMenuItem;
    mniDeleteAutoInsertPlanetCommand: TMenuItem;
    mniInsertFindCommands: TMenuItem;
    mniUpgrade: TMenuItem;
    LoadAllCOLSendto: TMenuItem;
    LoadAllCAPSendto: TMenuItem;
    SendAllto: TMenuItem;
    tshShipsInProduction: TTabSheet;
    lvShipsInProduction: TdfsExtListView;
    OvcFormState1: TOvcFormState;
    OvcComponentState1: TOvcComponentState;
    mniExportListview: TMenuItem;
    ExportExtListView1: TExportExtListView;
    mniFirstTurn: TMenuItem;
    mniNewTurn: TMenuItem;
    mniCreateOrders: TMenuItem;
    mniAutomaticLoadSendCargo: TMenuItem;
    mniAutomaticSendEmptyShips: TMenuItem;
    mniSetupOrders: TMenuItem;
    mniDeleteKnownShipTypes: TMenuItem;
    mnuToDevelop: TPopupMenu;
    mniAddAsDevToClipboardAllNonDevOwned: TMenuItem;
    N1: TMenuItem;
    mniViewPlanetInMap: TMenuItem;
    mniFindPlanetInOrders: TMenuItem;
    mniFindNextPlanetInOrders: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    CreateOrder1: TMenuItem;
    mniChangeName: TMenuItem;
    mniQuitGame: TMenuItem;
    DecrementTurnCounter1: TMenuItem;
    DevelopStdShiptypeOnthisPlanet1: TMenuItem;
    DefaultSpeed1: TMenuItem;
    SpeedItem1: TMenuItem;
    DefaultWeapons1: TMenuItem;
    DefaultShields1: TMenuItem;
    WeaponsItem1: TMenuItem;
    ShieldsItem1: TMenuItem;
    N6: TMenuItem;
    DefaultUseTurns1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N7: TMenuItem;
    mniAllAbove: TMenuItem;
    N8: TMenuItem;
    Settings1: TMenuItem;
    FindGroupinOrders1: TMenuItem;
    FindNextGroupinOrders1: TMenuItem;
    ReplaceProductionType1: TMenuItem;
    ReplaceProductionTypeToStandardShip1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    N10: TMenuItem;
    SearchAndView1: TMenuItem;
    N12: TMenuItem;
    AutoInsertPlanetCommands: TMenuItem;
    DeleteAutoInsertGroupCommands1: TMenuItem;
    AutoInsertOtherCommands: TMenuItem;
    Changeemailadress1: TMenuItem;
    N9: TMenuItem;
    ChangePassword1: TMenuItem;
    DeleteAutoInsertOtherCommands1: TMenuItem;
    SaveordersCRonly1: TMenuItem;
    SaveordersLFonly1: TMenuItem;
    SaveOrders1: TMenuItem;
    DeleteAutoInsertRouteCommands: TMenuItem;
    AutoInsertRouteCommands: TMenuItem;
    Memo1: TmwCustomEdit;
    mkGalaxySyn: TmkGalaxySyn;
    N13: TMenuItem;
    UseRoutesForDevelopment1: TMenuItem;
    N14: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mniStayOnTopClick(Sender: TObject);
    procedure mniHideClick(Sender: TObject);
    procedure mniGalaxyServeradressClick(Sender: TObject);
    procedure mniSubjectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure mniLoadordersClick(Sender: TObject);
    procedure mniSaveordersClick(Sender: TObject);
    procedure mniMailordersClick(Sender: TObject);
    procedure mniPlaceinOutboxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnAnalyseClick(Sender: TObject);
    procedure Memo2DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Memo2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lvSendedShipsClick(Sender: TObject);
    procedure lvSendedShipsDblClick(Sender: TObject);
    procedure dummyCOLSEND1Click(Sender: TObject);
    procedure dummyCAPSEND1Click(Sender: TObject);
    procedure dummyAllCOLSENDClick(Sender: TObject);
    procedure dummyAllCAPSENDClick(Sender: TObject);
    procedure dummySEND1Click(Sender: TObject);
    procedure dummyAllSENDClick(Sender: TObject);
    procedure popupToDoPopup(Sender: TObject);
    procedure lvToDoClick(Sender: TObject);
    procedure lvToDevelopClick(Sender: TObject);
    procedure lvToTransportClick(Sender: TObject);
    procedure lvDevelopingClick(Sender: TObject);
    procedure lvLoadedSendDblClick(Sender: TObject);
    procedure mniAutoInsertCommandsClick(Sender: TObject);
    procedure mniDeleteAutoInsertPlanetCommandClick(Sender: TObject);
    procedure mniInsertFindCommandsClick(Sender: TObject);
    procedure mniUpgradeClick(Sender: TObject);
    procedure lvShipsInProductionClick(Sender: TObject);
    procedure mniOptionsClick(Sender: TObject);
    procedure mniExportListviewClick(Sender: TObject);
    procedure mniAutoMaticLoadAndSendClick(Sender: TObject);
    procedure mniAutomaticSendEmptyShipsClick(Sender: TObject);
    procedure mniSetupOrdersClick(Sender: TObject);
    procedure mniDeleteKnownShipTypesClick(Sender: TObject);
    procedure mniAddAsDevToClipboardAllNonDevOwnedClick(Sender: TObject);
    procedure mniFindNextPlanetInOrdersClick(Sender: TObject);
    procedure mniFindPlanetInOrdersClick(Sender: TObject);
    procedure lvDevelopingDblClick(Sender: TObject);
    procedure lvToTransportDblClick(Sender: TObject);
    procedure lvToDevelopDblClick(Sender: TObject);
    procedure lvShipsInProductionDblClick(Sender: TObject);
    procedure mniChangeNameClick(Sender: TObject);
    procedure mniQuitGameClick(Sender: TObject);
    procedure DecrementTurnCounter1Click(Sender: TObject);
    procedure DevelopStdShiptypeOnthisPlanet1Click(Sender: TObject);
    procedure SpeedItem1Click(Sender: TObject);
    procedure WeaponsItem1Click(Sender: TObject);
    procedure ShieldsItem1Click(Sender: TObject);
    procedure DefaultSpeed1Click(Sender: TObject);
    procedure DefaultWeapons1Click(Sender: TObject);
    procedure DefaultShields1Click(Sender: TObject);
    procedure DefaultUseTurns1Click(Sender: TObject);
    procedure DefaultUseTurnsItemsClick(Sender: TObject);
    procedure mniAllAboveClick(Sender: TObject);
    procedure CompleteFillPlanetwithCAP1Click(Sender: TObject);
    procedure FindGroupinOrders1Click(Sender: TObject);
    procedure FindNextGroupinOrders1Click(Sender: TObject);
    procedure ReplaceProductionType1Click(Sender: TObject);
    procedure ReplaceProductionTypeToStandardShip1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure DeleteAutoInsertGroupCommands1Click(Sender: TObject);
    procedure AutoInsertPlanetCommandsClick(Sender: TObject);
    procedure AutoInsertOtherCommandsClick(Sender: TObject);
    procedure Changeemailadress1Click(Sender: TObject);
    procedure ChangePassword1Click(Sender: TObject);
    procedure DeleteAutoInsertOtherCommands1Click(Sender: TObject);
    procedure SaveordersCRonly1Click(Sender: TObject);
    procedure SaveordersLFonly1Click(Sender: TObject);
    procedure DeleteAutoInsertRouteCommandsClick(Sender: TObject);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UseRoutesForDevelopment1Click(Sender: TObject);
    procedure lvLoadedSendDrawItem(Control: TWinControl;
      var ACanvas: TCanvas; Index: Integer; ARect: TRect;
      State: TOwnerDrawState; var DefaultDrawing, FullRowSelect: Boolean);
  private
    FstrFind: string;
    FFoundAt: integer;
    FstrGroupFind: string;
    FGroupFoundAt: integer;

    FGalaxyServerAdress: string;
    FSubject: string;
    procedure ParseRecipients(Recipients: string; List: TStrings);
    procedure GetSendedGroups;
    procedure GetToDevelop;
    function GetGroupOrdersInsertionPoint: integer;
    function GetPlanetOrdersInsertionPoint: integer;
    function GetOtherOrdersInsertionPoint: integer;
    function GetRouteOrdersInsertionPoint: integer;
    function GetFindOrdersInsertionPoint(Lines: TStrings): integer;
    procedure LoadGroupWithAndSend(strGroup, strPlanet, strCargoType: string;
      intGroupMax, intGroupSend: integer);
    function TurnTagLine: integer;
    function GetUseRoutesForDevelopment: boolean;
    procedure SetUseRoutesForDevelopment(const Value: boolean);
    { Private declarations }
  public
    property GalaxyServerAdress: string read FGalaxyServerAdress
      write FGalaxyServerAdress;
    property Subject: string read FSubject write FSubject;
    property UseRoutesForDevelopment: boolean read GetUseRoutesForDevelopment
      write SetUseRoutesForDevelopment;
    { Public declarations }
    procedure InsertCommand(strCommand: string);
    procedure InsertPlanetCommand(strCommand: string);
    procedure InsertOtherCommand(strCommand: string);
    procedure InsertRouteCommand(strCommand: string);
    procedure AnalyseAndDoOutput;
    procedure CalculateSendedShipsMass;
    procedure GetSendedGroupsOnRoutes;

    procedure FindNextPlanetInOrders;
    procedure FindFirstPlanetInOrders(PlanetName: string);
    function GetPlanetAtCurrentPosLine: TPlanet;
    procedure FindNextGroupInOrders;
    procedure FindFirstGroupInOrders(GroupNr: string);
    function GetGroupAtCurrentPosLine: TGroup;

    function FindTurnTag: integer;
    procedure SetTurnTag(turn: integer);

    procedure DoAnalyseButton;

    procedure FindRenameOrders(aRenameplanetsList: TStrings);
  end;

  TSendedGroup = class(TObject)
    orgGroup: TGroup;
    sendFrom: TPlanet;
    sendTo: TPlanet;
    sendToGo: single;
    sendAantal: integer;
    Upgrade: boolean;
    IsOrgGroup: boolean;
    sendQuantity: Single;
    sendCargoType: integer;
    ETA: integer;
    function GetSpeed: single;
  end;

var
  frmOrders: TfrmOrders;
  SendedGroups: TStringList;

procedure CreateDistanceList(list: TList; SortOnArray: TSortOnArray);
procedure ClearMenuItems(menuItem: TmenuItem);
function GetMaxToSend(group: TGroup): integer;

function FindSendedGroup(nr: integer): TSendedGroup;
procedure BreakSendedGroup(var SendedGroup: TSendedGroup; aantal: integer);

implementation

uses UfrmMain, UFiles, UDevelop, UfrmPlanets, HyperStr, Clipbrd, USortingAlgorithems,
  UfrmSetupOrders, MKstrUtils, UfrmShipDesign, UfrmStdShip, UfrmGroups,
  UfrmPlanetslist, xProcs, UfrmRoutes;

{$R *.DFM}

var
  strGroup: string;
  intGroupMax: integer;

function GetMaxToSend(group: TGroup): integer;
var
  i: integer;
  SendedGroup: TSendedGroup;
begin
  Result := group.Aantal;
  for i := 0 to SendedGroups.Count - 1 do begin
    SendedGroup := TSendedGroup(SendedGroups.Objects[i]);
    if Assigned(SendedGroup.sendTo) and (SendedGroup.orgGroup = group) then
      Result := Result - SendedGroup.sendAantal
    else
      if SendedGroup.Upgrade and (SendedGroup.orgGroup = group) then
        Result := 0;
  end;
  if Result < 0 then Result := 0;
end;

procedure ClearMenuItems(menuItem: TmenuItem);
begin
  while menuItem.Count > 0 do
    menuItem.Delete(0);
end;

function TSendedGroup.GetSpeed: single;
begin
  if orgGroup._Type.Mass > 0 then begin
    if orgGroup.EffCargo > 0 then
      Result := 20 * (orgGroup._Type.Drive * orgGroup.DriveTech) /
        (orgGroup._Type.Mass + sendQuantity / orgGroup.CargoTech)
    else
      Result := 20 * (orgGroup._Type.Drive * orgGroup.DriveTech) /
        (orgGroup._Type.Mass { + sendAantal});
  end else
    Result := 0;
end;

function GetOrderPlaneet(var strLine: string; var planet: TPlanet): boolean;
var
  ipos, found: integer;
begin
  Result := False;
  if Length(strLine) = 0 then Exit;
  ipos := pos(' ', strLine);
  if ipos = 0 then ipos := Length(strLine)
  else dec(ipos);
  found := planets.IndexOf(lowercase(copy(strLine, 1, ipos)));
  if found <> -1 then
  begin
    planet := TPlanet(planets.Objects[found]);
    Result := true;
  end;
  strLine := trim(copy(strLine, ipos + 1, Length(strLine)));
end;

function GetOrderProduce(var strLine: string; var produce: integer): boolean;
var
  ipos: integer;
begin
  Result := False;
  if Length(strLine) = 0 then Exit;
  ipos := pos(' ', strLine);
  if ipos = 0 then ipos := Length(strLine)
  else dec(ipos);
  if lowercase(copy(strLine, 1, ipos)) = 'mat' then
    produce := P_MAT
  else
    if lowercase(copy(strLine, 1, ipos)) = 'cap' then
      produce := P_CAP
    else
      if lowercase(copy(strLine, 1, ipos)) = 'col' then
        produce := P_COL;
  Result := (produce <> 0);
  strLine := trim(copy(strLine, ipos + 1, Length(strLine)));
end;

function FindSendedGroup(nr: integer): TSendedGroup;
var
  i: integer;
begin
      i := 0;
      Result := nil;
      while (i < SendedGroups.Count) and (Result = nil) do
      begin
        if TSendedGroup(SendedGroups.Objects[i]).OrgGroup.Nr = nr then
          Result := TSendedGroup(SendedGroups.Objects[i]);
        inc(i);
      end;
end;

procedure FindNextSendedGroup(var SendedGroup: TSendedGroup; nr: integer);
var
  i: integer;
begin
  i := 0;
  while (i < SendedGroups.Count) and (TSendedGroup(SendedGroups.Objects[i]) <> SendedGroup) do
    inc(i);
  if TSendedGroup(SendedGroups.Objects[i]) = SendedGroup then begin
    inc(i);
    SendedGroup := nil;
    while (i < SendedGroups.Count) and (SendedGroup = nil) do
    begin
      if TSendedGroup(SendedGroups.Objects[i]).OrgGroup.Nr = nr then
        SendedGroup := TSendedGroup(SendedGroups.Objects[i]);
      inc(i);
    end;
  end else
    SendedGroup := nil;
end;


function GetOrderGroup(var strLine: string; var sendGroup: TSendedGroup): boolean;
var
  ipos: integer;
  nr: integer;
begin
  Result := False;
  if Length(strLine) = 0 then Exit;
  ipos := pos(' ', strLine);
  if ipos = 0 then ipos := Length(strLine)
  else dec(ipos);
  if IsNum(copy(strLine, 1, ipos)) then
  begin
    try
      nr := StrToInt(copy(strLine, 1, ipos));
      sendGroup := FindSendedGroup(nr);
    except
      ;
    end;
  end
  else
  begin
    if lowercase(copy(strLine, 1, ipos)) = 'max' then
      if qreportPlayer.Groups.Count > 0 then
        sendGroup := TSendedGroup(SendedGroups.Objects[SendedGroups.count - 1]);
  end;
  Result := (sendGroup <> nil);
  strLine := trim(copy(strLine, ipos + 1, Length(strLine)));
end;

function GetOrderAantal(var strLine: string; var aantal: integer): boolean;
var
  ipos: integer;
begin
  Result := False;
  if (Length(strLine) = 0) or (strLine[1] = ';') then Exit;
  ipos := pos(' ', strLine);
  if ipos = 0 then ipos := Length(strLine)
  else dec(ipos);
  try
    aantal := StrToInt(copy(strLine, 1, ipos));
    Result := True;
  except
    aantal := 0;
  end;
  strLine := trim(copy(strLine, ipos + 1, Length(strLine)));
end;

function ParseOrderLine(strLine: string; var command: integer; var planet: TPlanet;
  var sendGroup: TsendedGroup; var produce: integer;
  var aantal: integer): boolean;
begin
  Result := False;
  planet := nil;
  sendGroup := nil;
  produce := 0;
  aantal := 0;
  command := 0;
  strLine := trim(strLine);
  if Length(strLine) = 0 then Exit;
  case strLine[1] of
    'P', 'p': command := OCMD_PRODUCE; // p planeetnaam whattoproduce
    'S', 's': command := OCMD_SEND; // s group planeetnaam [aantal]
    'I', 'i': command := OCMD_INTERCEPT; // i group planeetnaam [aantal]
    'B', 'b': command := OCMD_BREAK; // b group aantal
    'L', 'l': command := OCMD_LOAD; // l group whattoload
    'R', 'r': command := OCMD_ROUTE; // r planet Whattoship [planetdest]
    'U', 'u': command := OCMD_UNLOAD; // u group [aantal]
    'G', 'g': command := OCMD_UPGRADE; // g group
  end;
  strLine := copy(strLine, 2, Length(strLine));
  strLine := trim(strLine);
  if Length(strLine) = 0 then Exit;
  case command of
    OCMD_PRODUCE:
      begin
        if GetOrderPlaneet(strLine, planet) then
        begin
          Result := true;
          GetOrderProduce(strLine, produce);
        end;
      end;
    OCMD_SEND:
      begin
        if GetOrderGroup(strLine, sendGroup) then
          if GetOrderPlaneet(strLine, planet) then
          begin
            GetOrderAantal(strLine, aantal);
            Result := true;
          end;
      end;
    OCMD_UPGRADE:
      begin
        if GetOrderGroup(strLine, sendGroup) then
          Result := true;
      end;
    OCMD_INTERCEPT:
      begin
        if GetOrderGroup(strLine, sendGroup) then
          if GetOrderPlaneet(strLine, planet) then
          begin
            GetOrderAantal(strLine, aantal);
            Result := true;
          end;
      end;
    OCMD_BREAK:
      begin
        if GetOrderGroup(strLine, sendGroup) then
          if GetOrderAantal(strLine, aantal) then
            Result := true;
      end;
    OCMD_LOAD:
      begin
        if GetOrderGroup(strLine, sendGroup) then
          if GetOrderProduce(strLine, produce) then begin
            GetOrderAantal(strLine, aantal);
            Result := true;
          end;
      end;
    OCMD_ROUTE: // r planet Whattoship [planetdest]
      begin
        if GetOrderPlaneet(strLine, planet) then
          if GetOrderProduce(strLine, produce) then
            Result := true;
      end;
    OCMD_UNLOAD: // u group [aantal]
      begin
        if GetOrderGroup(strLine, sendGroup) then begin
          GetOrderAantal(strLine, aantal);
          Result := true;
        end;
      end;
  else
    while (strLine <> '') and (planet = nil) do
      Result := GetOrderPlaneet(strLine, planet);
  end;

end;

function GetPlanetFromOrderLine(strLine: string): Tplanet;
var
  planet: TPlanet;
  sendGroup: TSendedGroup;
  command,
    produce,
    aantal: integer;
begin
  Result := nil;
  if ParseOrderLine(strLine, command, Planet, sendGroup, produce, aantal) then
    if planet <> nil then
      Result := planet
    else
      if sendGroup <> nil then
        Result := sendGroup.orgGroup.Planet;
end;

function GetGroupFromOrderLine(strLine: string): TGroup;
var
  planet: TPlanet;
  sendGroup: TSendedGroup;
  command,
    produce,
    aantal: integer;
begin
  Result := nil;
  if ParseOrderLine(strLine, command, Planet, sendGroup, produce, aantal) then
    if sendGroup <> nil then
      Result := sendGroup.orgGroup;
end;

procedure TfrmOrders.GetToDevelop;
var
  planet: TPlanet;
  i: integer;
  listItem: TListItem;
begin
  lvToDevelop.BeginUpdate;
  try
    lvToDevelop.items.clear;
    for i := 0 to planets.Count - 1 do
    begin
      planet := TPlanet(planets.objects[i]);
      if (planet.PlayerCur = qReportPlayer) and
        ((planet.PopulationCur < planet.Size) or (planet.IndustryCur < planet.Size)) then
      begin
        listItem := lvToDevelop.items.Add;
        listItem.Caption := planet.Name;
        listItem.SubItems.Add(format('%5.2f', [planet.size]));
        listItem.SubItems.Add(format('%5.2f', [planet.PopulationCur]));
        listItem.SubItems.Add(format('%5.2f', [planet.IndustryCur]));
        listItem.Data := planet;
      end;
    end;
  finally
    lvToDevelop.EndUpdate;
  end;
  lvToDevelop.CurrentSortAscending := True;
end;

procedure BreakSendedGroup(var SendedGroup: TSendedGroup; aantal: integer);
  var
    newSendedGroup: TSendedGroup;
  begin
    newSendedGroup := TSendedGroup.Create;
    newSendedGroup.Upgrade := False;
    newSendedGroup.orgGroup := SendedGroup.orgGroup;
    SendedGroups.AddObject(InttoStr(newSendedGroup.orgGroup.Nr), newSendedGroup);
    newSendedGroup.sendFrom := SendedGroup.sendFrom;
    newSendedGroup.sendTo := SendedGroup.sendTo;
    newSendedGroup.sendToGo := SendedGroup.sendToGo;
    newSendedGroup.sendAantal := aantal;
    newSendedGroup.sendQuantity := SendedGroup.sendQuantity;
    newSendedGroup.sendCargoType := SendedGroup.sendCargoType;
    newSendedGroup.IsOrgGroup := false;
    SendedGroup.sendAantal := SendedGroup.sendAantal - aantal;
    SendedGroup := newSendedGroup; // return the new created group
  end;

procedure TfrmOrders.GetSendedGroups;
var
  i: integer;
  strTemp: string;
  command, produce, aantal: integer;
  distance: single;
  planet: TPlanet;
  SendedGroup: TSendedGroup;
  listItem: TListItem;
  vX1: Single;
  vY1: Single;
  vX2: Single;
  vY2: Single;
begin
  while SendedGroups.Count > 0 do
  begin
    TSendedGroup(SendedGroups.Objects[0]).Free;
    SendedGroups.Delete(0);
  end;
  if qReportPlayer.Groups.Count = 0 then Exit;
  for i := 0 to qReportPlayer.Groups.Count - 1 do
  begin
    SendedGroup := TSendedGroup.Create;
    SendedGroup.Upgrade := False;
    SendedGroup.IsOrgGroup := true;
    SendedGroup.orgGroup := TGroup(qReportPlayer.Groups.items[i]);
    if SendedGroup.orgGroup.Range = 0 then begin
      SendedGroup.sendFrom := SendedGroup.orgGroup.Planet;
      SendedGroup.ETA := 0;
    end else begin
      SendedGroup.sendFrom := SendedGroup.orgGroup.LocPlanet;
      SendedGroup.sendTo := SendedGroup.orgGroup.Planet;
      distance := SendedGroup.orgGroup.Range; { - SendedGroup.orgGroup.EffSpeedNow;
      if distance < 0 then distance := 0;}
      SendedGroup.sendToGo := distance; //SendedGroup.orgGroup.Range;
      if (distance > 0) and (SendedGroup.GetSpeed > 0) then
        SendedGroup.ETA := trunc(distance / SendedGroup.GetSpeed) + 1
      else
        SendedGroup.ETA := 0;
    end;
    SendedGroup.sendQuantity := SendedGroup.orgGroup.Lading;
    SendedGroup.sendCargoType := SendedGroup.orgGroup.LadingType;
    SendedGroup.sendAantal := SendedGroup.orgGroup.Aantal;
    SendedGroups.AddObject(InttoStr(SendedGroup.orgGroup.Nr), SendedGroup);
  end;
  for i := 0 to Memo1.lines.Count - 1 do
  begin
    strTemp := Memo1.lines[i];
    if Length(strTemp) > 0 then
    begin
      if strTemp[1] <> ';' then
      begin
        if ParseOrderLine(strTemp, command, planet, SendedGroup, produce, aantal) then
        begin
          case command of
            OCMD_LOAD:
              begin
                if (SendedGroup = nil) and not Assigned(SendedGroup.orgGroup) then continue;
                if aantal > 0 then begin
                  if aantal < SendedGroup.sendAantal then
                    BreakSendedGroup(SendedGroup, aantal);
                end;
              end;
            OCMD_SEND:
              begin
                if SendedGroup = nil then continue;
                if Assigned(SendedGroup.orgGroup) and (SendedGroup.orgGroup.EffSpeed = 0) then Exit;
                if aantal > 0 then begin
                  if aantal < SendedGroup.sendAantal then
                    BreakSendedGroup(SendedGroup, aantal);
                end;
                SendedGroup.sendTo := pLanet;
                vX1 := SendedGroup.sendTo.x;
                vY1 := SendedGroup.sendTo.y;
                vX2 := SendedGroup.sendFrom.x;
                vY2 := SendedGroup.sendFrom.y;
                distance := round(sqrt((vX1 - vX2) * (vX1 - vX2) +
                  (vY1 - vY2) * (vY1 - vY2))) / 100;
                SendedGroup.sendToGo := distance;
                if (distance > 0) and (SendedGroup.GetSpeed > 0) then
                  SendedGroup.ETA := trunc(distance / SendedGroup.GetSpeed) + 1
                else
                  SendedGroup.ETA := 0;
              end;
            OCMD_INTERCEPT:
              begin
                if SendedGroup = nil then continue;
                if Assigned(SendedGroup.orgGroup) and (SendedGroup.orgGroup.EffSpeed = 0) then Exit;
                if aantal > 0 then begin
                  if aantal < SendedGroup.sendAantal then
                    BreakSendedGroup(SendedGroup, aantal);
                end;
                SendedGroup.sendTo := pLanet;
                vX1 := SendedGroup.sendTo.x;
                vY1 := SendedGroup.sendTo.y;
                vX2 := SendedGroup.sendFrom.x;
                vY2 := SendedGroup.sendFrom.y;
                distance := round(sqrt((vX1 - vX2) * (vX1 - vX2) +
                  (vY1 - vY2) * (vY1 - vY2))) / 100;

                SendedGroup.sendToGo := distance;
                if (distance > 0) and (SendedGroup.GetSpeed > 0) then
                  SendedGroup.ETA := trunc(distance / SendedGroup.GetSpeed) + 1
                else
                  SendedGroup.ETA := 0;
              end;
            OCMD_BREAK:
              begin
                if SendedGroup = nil then continue;
                if aantal > 0 then
                begin
                  if aantal >= SendedGroup.SendAantal then
                  else
                    BreakSendedGroup(SendedGroup, aantal);
                end;
              end;
            OCMD_UPGRADE:
              begin
                if SendedGroup = nil then continue;
                SendedGroup.Upgrade := True;
              end;
            OCMD_UNLOAD:
              begin
                if SendedGroup = nil then continue;
                if not Assigned(SendedGroup.orgGroup)
                   or (SendedGroup.orgGroup.range > 0) then continue;
{                if aantal > 0 then begin
                  if aantal < SendedGroup.sendAantal then
                    BreakSendedGroup(SendedGroup, SendedGroup.sendAantal - aantal);
                end;}
                SendedGroup.sendQuantity := 0;
                SendedGroup.sendCargoType := 0;
              end;
          end;
        end;
      end;
    end;
  end;

  GetSendedGroupsOnRoutes;

  lvSendedShips.BeginUpdate;
  try
    lvSendedShips.Items.Clear;
    for i := 0 to SendedGroups.Count - 1 do
    begin
      SendedGroup := TSendedGroup(SendedGroups.Objects[i]);
      if (SendedGroup.sendTo <> nil) and (SendedGroup.OrgGroup.EffCargo = 0) then
      begin
        distance := SendedGroup.SendToGo - SendedGroup.OrgGroup.EffSpeed;
        if distance < 0 then distance := 0;
        listItem := lvSendedShips.Items.Add;
        listItem.Caption := IntToStr(SendedGroup.OrgGroup.Nr);
        listItem.Data := SendedGroup;
        listItem.SubItems.Add(IntToStr(SendedGroup.SendAantal));
        if Assigned(SendedGroup.SendFrom) then
          listItem.SubItems.Add(SendedGroup.SendFrom.Name)
        else
          listItem.SubItems.Add('?');
        listItem.SubItems.Add(SendedGroup.SendTo.Name);
        listItem.SubItems.Add(Format('%5.2f', [SendedGroup.SendToGo]));
        listItem.SubItems.Add(Format('%5.2f', [SendedGroup.OrgGroup.EffSpeed]));
        listItem.SubItems.Add(Format('%5.2f', [distance]));
        try
          if SendedGroup.OrgGroup.EffSpeed > 0 then
            listItem.ImageIndex := trunc(SendedGroup.sendToGo / SendedGroup.OrgGroup.EffSpeed)
          else
            listItem.ImageIndex := -1;
        except
          listItem.ImageIndex := -1;
        end;
      end;
    end;
  finally
    lvSendedShips.EndUpdate;
  end;
  lvSendedShips.CurrentSortAscending := True;
end;

procedure TfrmOrders.ParseRecipients(Recipients: string; List: TStrings);
var
  Recip: string;
  I: Integer;
begin
  List.BeginUpdate;
  try
    List.Clear;
    if Recipients <> SNONE then
    begin
      I := Pos(';', Recipients);
      while I <> 0 do
      begin
        Recip := Trim(Copy(Recipients, 1, I - 1));
        if Recip <> '' then
          List.Add(Recip);
        Delete(Recipients, 1, I);
        I := Pos(';', Recipients);
      end;
      Recip := Trim(Recipients);
      if Recip <> '' then
        List.Add(Recip);
    end;
  finally
    List.EndUpdate;
  end;
end;

procedure TfrmOrders.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmOrders.mniStayOnTopClick(Sender: TObject);
begin
  mniStayOnTop.Checked := not mniStayOnTop.Checked;
  if mniStayOnTop.Checked then FormStyle := fsStayonTop
  else
  begin
    FormStyle := fsNormal;
    frmMKGal.FormStyle := fsStayonTop;
  end;
  WindowState := wsNormal;
end;

procedure TfrmOrders.mniHideClick(Sender: TObject);
begin
  WindowState := wsMinimized;
end;

procedure TfrmOrders.mniGalaxyServeradressClick(Sender: TObject);
var
  newAdress: string;
begin
  newAdress := FGalaxyServerAdress;
  if InputQuery('Galaxy Server adress', 'Enter Galaxy Server adress', newAdress) then
    FGalaxyServerAdress := newAdress;
end;

procedure TfrmOrders.mniSubjectClick(Sender: TObject);
var
  newSubject: string;
begin
  newSubject := Subject;
  if InputQuery('Order subject', 'Enter subject line of order', newSubject) then
    Subject := newSubject;
end;

procedure TfrmOrders.FormShow(Sender: TObject);
var
  i: integer;
  ShipInProduction: TShipInProduction;
begin
  try
    OvcComponentState1.Section := 'game_' + GetGameStr;
    OvcComponentState1.RestoreState;
    OvcComponentState1.Storage.Open;
    FGalaxyServerAdress := OvcComponentState1.Storage.ReadString('game_' + GetGameStr, 'GalaxyServerAdress', '');
    FSubject := OvcComponentState1.Storage.ReadString('game_' + GetGameStr, 'Subject', '');
    OvcComponentState1.Storage.Close;
  except

  end;
  try
    if FileExists(ExtractFilePath(ParamStr(0)) + 'orders_' + GetGameStr) then
      Memo1.Lines.LoadFromFile(ExtractFilePath(ParamStr(0)) + 'orders_' + GetGameStr);
  except

  end;
  if inivars.Gametype = gtGalaxyBlind then begin
    mniInsertFindCommands.Visible := false;
  end;
  i := FindTurnTag;
  if (i <> LastTurn) then begin
    if (i <> -1) and question('Delete old orders?') then
      mniAllAboveClick(nil);
    SetTurnTag(LastTurn);
  end;
  try
    AnalyseerOrders(true, UseRoutesForDevelopment);
    DoOutput;
    GetSendedGroups;
    GetToDevelop;
    CalculateSendedShipsMass;
  except

  end;
  lvShipsInProduction.BeginUpdate;
  try
    lvShipsInProduction.Items.Clear;
    for i := 0 to ShipsInProduction.Count - 1 do begin
      ShipInProduction := TShipInProduction(ShipsInProduction.Items[i]);
      with lvShipsInProduction.Items.Add do begin
        Caption := ShipInProduction.PlanetName;
        Subitems.Add(ShipInProduction.ShipTypeName);
        Subitems.Add(IntToStr(ShipInProduction.NumberOfShipsPresent));
        Subitems.Add(IntToStr(ShipInProduction.NumberOfShipsPresentLastTech));
        Data := FindPlanetWithName(ShipInProduction.PlanetName);
      end;
    end;
  finally
    lvShipsInProduction.EndUpdate;
  end;
  if memo1.Lines.Count > 1 then
    while (memo1.Lines.Count > 1) and (memo1.Lines[0] = '') do
      Memo1.Lines.Delete(0);
  Memo1.SetSelStart(0);
  Memo1.SetSelEnd(0);
  //Memo1.SelStart := 0;
end;

procedure TfrmOrders.FormHide(Sender: TObject);
begin
  try
    Memo1.Lines.SaveToFile(ExtractFilePath(ParamStr(0)) + 'orders_' + GetGameStr);
    Memo1.Lines.Clear;
  except

  end;
  OvcComponentState1.Section := 'game_' + GetGameStr;
  OvcComponentState1.SaveState;
  OvcComponentState1.Storage.Open;
  OvcComponentState1.Storage.WriteString('game_' + GetGameStr, 'GalaxyServerAdress', FGalaxyServerAdress);
  OvcComponentState1.Storage.WriteString('game_' + GetGameStr, 'Subject', FSubject);
  OvcComponentState1.Storage.Close;
end;

procedure TfrmOrders.mniLoadordersClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    if FileExists(OpenDialog1.FileName) then begin
      Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
      Memo1.SetSelStart(0);
      Memo1.SetSelEnd(0);
      //Memo1.SelStart := 0;
    end;
end;

procedure TfrmOrders.mniSaveordersClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    Memo1.Lines.SaveToFile(SaveDialog1.FileName);
    Application.MessageBox(PChar(STxtMesSaved), PChar(StitMesSaved), MB_OK);
  end;
end;

procedure TfrmOrders.mniMailordersClick(Sender: TObject);
var
  intMapRes: integer;
  OldCursor: TCursor;
  strMessage: string;
begin
  OldCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    ParseRecipients(FGalaxyServerAdress, Email.Recipient);
    strMessage := Memo1.Text;
    Email.SetLongText(PChar(strMessage));
    Email.Subject := Subject;
    Email.UseDefProfile := True;
    Email.Attachment.Clear;
    Email.CC.Clear;
    Email.BCC.Clear;
    try
      if not mniPlaceinOutbox.Checked then
      begin
        intMapRes := Email.SendMail;
        if (intMapRes <> EMAIL_OK) then
          MessageDlg(Format(SMAPISmFailed, [intMapRes]), mtError, [mbAbort], 0);
      end
      else
      begin
        intMapRes := Email.SaveMail;
        if (intMapRes <> EMAIL_OK) then
          MessageDlg(Format(SMAPISvFailed, [intMapRes]), mtError, [mbAbort], 0);
      end;
    except
      on e: Exception do Application.ShowException(E);
    end;
  finally
    Screen.Cursor := OldCursor;
  end;
end;

procedure TfrmOrders.mniPlaceinOutboxClick(Sender: TObject);
begin
  mniPlaceinOutbox.Checked := not mniPlaceinOutbox.Checked;
end;

procedure TfrmOrders.FormCreate(Sender: TObject);

  procedure CreateDefaultMenuItems(menuItem: TMenuItem; strings: TStrings; proc: TNotifyevent);
  var
    NewMenuItem: TMenuItem;
    i: integer;
  begin
    for i := 0 to strings.Count - 1 do begin
      NewMenuItem := TmenuItem.Create(nil);
      NewMenuItem.Caption := strings[i];
      NewMenuItem.GroupIndex := menuItem.Tag;
      NewMenuItem.RadioItem := True;
      NewMenuItem.OnClick := proc;
      menuItem.Add(NewMenuItem);
    end;
  end;

begin
  ClearMenuItems(DefaultSpeed1);
  ClearMenuItems(DefaultWeapons1);
  ClearMenuItems(DefaultShields1);
  CreateDefaultMenuItems(DefaultSpeed1, frmStdShip.SpeedItems, SpeedItem1Click);
  CreateDefaultMenuItems(DefaultWeapons1, frmStdShip.WeaponsItems, WeaponsItem1Click);
  CreateDefaultMenuItems(DefaultShields1, frmStdShip.ShieldsItems, ShieldsItem1Click);

  SetOrderTstrings(Memo1.Lines);
  SetDevelopingListview(lvDeveloping);
  SetLoadedSendListview(lvLoadedSend);
  SetToTransportListview(lvToTransport);
  SetToDoListview(lvToDo);
  SendedGroups := TStringList.Create;
end;

procedure TfrmOrders.btnAnalyseClick(Sender: TObject);
begin
  DoAnalyseButton;
end;

procedure TfrmOrders.DoAnalyseButton;
var
  OldCur: TCursor;
begin
  OldCur := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    InitBuildability;
    AnalyseerOrders(true, UseRoutesForDevelopment);
    DoOutput;
    GetSendedGroups;
    GetToDevelop;
    CalculateSendedShipsMass;
    frmGroups.DoRefresh;
    frmPlanetsList.DoRefresh;
    frmShipDesign.RefreshShipTypes;
    frmRoutes.DoFillLvRoutes;
    frmPlanets.DoRefresh;
  finally
    Screen.Cursor := OldCur;
  end;
end;

procedure TfrmOrders.Memo2DblClick(Sender: TObject);
var
  planet: Tplanet;
begin
  planet := GetPlanetAtCurrentPosLine;
  if planet <> nil then
    frmPlanets.ShowPlanet2(Planet, true);
end;

function TfrmOrders.GetPlanetAtCurrentPosLine: TPlanet;
var
  PointedAt: integer;
  startOfLine: integer;
  endOfLine: integer;
  sLine: string;
begin
  Result := nil;
  //PointedAt := Memo1.SelStart;
  PointedAt := Memo1.GetSelStart;
  startOfLine := scanb(Memo1.Text, #10, PointedAt);
  if startOfLine < 1 then startOfLine := 0;
  inc(startOfLine);
  endOfLine := scanc(Memo1.Text, #13, PointedAt);
  if endOfLine > Length(Memo1.Text) then endOfLine := Length(Memo1.Text);
  sLine := copy(memo1.text, StartOfLine, EndOfLine - StartOfLine);
  if sLine <> '' then
  begin
    if sLine[1] = ';' then sLine := trim(copy(sLine, 2, length(sLine)));
    Result := GetPlanetFromOrderLine(sLine);
  end;
end;

procedure TfrmOrders.FormDestroy(Sender: TObject);
begin
  while SendedGroups.Count > 0 do
  begin
    TSendedGroup(SendedGroups.Objects[0]).Free;
    SendedGroups.Delete(0);
  end;
  SendedGroups.Free;
end;

procedure TfrmOrders.Memo2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift) and ((Key = Ord('A')) or (Key = Ord('a'))) then
    Memo1.SelectAll;
end;

procedure TfrmOrders.lvSendedShipsClick(Sender: TObject);
begin
  if lvSendedShips.Selected <> nil then
    frmPlanets.ShowPlanet2(TsendedGroup(lvSendedShips.Selected.data).sendFrom, true);
end;

procedure TfrmOrders.lvSendedShipsDblClick(Sender: TObject);
begin
  if lvSendedShips.Selected <> nil then
    frmPlanets.ShowPlanet2(TsendedGroup(lvSendedShips.Selected.data).sendTo, true);
end;

procedure TfrmOrders.LoadGroupWithAndSend(strGroup, strPlanet, strCargoType: string; intGroupMax, intGroupSend: integer);
begin
  if intGroupSend < intGroupMax then
    InsertCommand('B ' + strGroup + {' 1'} ' ' + IntToStr(intGroupSend) + #13#10'L MAX ' + strCargoType + #13#10'S MAX ' + strPlanet)
  else
    InsertCommand('L ' + strGroup + ' ' + strCargoType + #13#10'S ' + strGroup + ' ' + strPlanet);
end;

procedure TfrmOrders.dummyCOLSEND1Click(Sender: TObject);
var
  menuItem: TmenuItem;
begin
  menuItem := TmenuItem(Sender);
  LoadGroupWithAndSend(strGroup, menuItem.Caption, 'COL', intGroupMax, 1);
  AnalyseAndDoOutput;
end;

procedure TfrmOrders.dummyCAPSEND1Click(Sender: TObject);
var
  menuItem: TmenuItem;
begin
  menuItem := TmenuItem(Sender);
  LoadGroupWithAndSend(strGroup, menuItem.Caption, 'CAP', intGroupMax, 1);
  AnalyseAndDoOutput;
end;

procedure TfrmOrders.dummyAllCOLSENDClick(Sender: TObject);
var
  menuItem: TmenuItem;
begin
  menuItem := TmenuItem(Sender);
  LoadGroupWithAndSend(strGroup, menuItem.Caption, 'COL', 0, 1);
  AnalyseAndDoOutput;
end;

procedure TfrmOrders.dummyAllCAPSENDClick(Sender: TObject);
var
  menuItem: TmenuItem;
begin
  menuItem := TmenuItem(Sender);
  LoadGroupWithAndSend(strGroup, menuItem.Caption, 'CAP', 0, 1);
  AnalyseAndDoOutput;
end;

procedure TfrmOrders.dummySEND1Click(Sender: TObject);
var
  menuItem: TmenuItem;
begin
  menuItem := TmenuItem(Sender);
  if intGroupMax > 1 then
    InsertCommand('S ' + strGroup + ' ' + menuItem.Caption + ' 1')
  else
    InsertCommand('S ' + strGroup + ' ' + menuItem.Caption);
  AnalyseAndDoOutput;
end;

procedure TfrmOrders.dummyAllSENDClick(Sender: TObject);
begin
  intGroupMax := 0;
  dummySEND1Click(Sender);
end;

procedure CreateMenuItem(const ParentItem: TMenuItem; const planet: TPlanet;
  const groupSpeed: single; const ClickEvent: TNotifyEvent);
var
  menuItem: TMenuItem;
begin
  menuItem := TmenuItem.Create(nil); //#SELF
  menuItem.Caption := planet.Name;
  if groupSpeed > 0 then
    menuItem.ImageIndex := trunc(planet.Distance / (groupSpeed * 100))
  else
    MenuItem.ImageIndex := -1;
  menuItem.OnClick := ClickEvent;
  if ((ParentItem.Count mod 20) = 0) and (ParentItem.Count > 0) then
    menuItem.Break := mbBarBreak;
  ParentItem.Add(menuItem);
end;

procedure TfrmOrders.popupToDoPopup(Sender: TObject);
var
  group: TGroup;
  groupSpeed: single;
  i: integer;
  planet: TPlanet;
  list: TList;
  AutoCAPFill: integer;
  AutoCOLFill: integer;
  SortOnArray: TSortOnArray;

  listView: TdfsExtListView;
  isOnRoute: boolean;
  sendedGroup: TSendedGroup;
begin
  if PageControl2.ActivePage = tshToDo then
    listView := lvToDo
  else
  if PageControl2.ActivePage = tshLoadedSend then
    listView := lvLoadedSend
  else
    Exit;
  if listView.Selected <> nil then
  begin
    sendedGroup := FindSendedGroup(TdevGroup(listView.Selected.data).orgGroup.Nr);
    isOnRoute := (TdevGroup(listView.Selected.data).devType = dtOnRoute) and
                 Assigned(sendedGroup) and not sendedGroup.Upgrade;
    AutoCAPFill := frmAutoCargoSettings.CAPFill;
    AutoCOLFill := frmAutoCargoSettings.COLFill;
    SortOnArray := frmAutoCargoSettings.SortOn;
    group := TdevGroup(listView.Selected.data).orgGroup;
    intGroupMax := TdevGroup(listView.Selected.data).devAantal;
    strGroup := listView.Selected.Caption;
    groupSpeed := group.EffSpeedLoaded;

    ClearMenuItems(LoadColSendto1);
    ClearMenuItems(LoadAllColSendto);

{# let op!}
    CalcDistForCOL(group, 0.0, AutoCOLFill);
    list := TList.Create;
    try
      CreateDistanceList(list, SortOnArray);
      i := 0;
      while (i < list.Count) and (i < 40) do begin
        planet := TPlanet(list[i]);
        CreateMenuItem(LoadColSendto1, planet, groupSpeed, dummyCOLSEND1Click);
        CreateMenuItem(LoadAllColSendto, planet, groupSpeed, dummyAllCOLSENDClick);
        inc(i);
      end;
    finally
      list.Free;
    end;
    LoadColSendto1.Enabled := i <> 0;
    LoadAllColSendto.Enabled := i <> 0;
    if listview = lvLoadedSend then begin
      LoadCOLSendto1.Enabled := (i <> 0) and isOnRoute;
      LoadAllCOLSendto.Enabled := (i <> 0) and isOnRoute;
    end;
{# let op!}
    CalcDistForCAP(group, 0.0, AutoCAPFill);

    ClearMenuItems(LoadCapSendto1);
    ClearMenuItems(LoadAllCapSendto);

    list := TList.Create;
    try
      CreateDistanceList(list, SortOnArray);
      i := 0;
      while (i < list.Count) and (i < 60) do begin
        planet := TPlanet(list[i]);
        CreateMenuItem(LoadCapSendto1, planet, groupSpeed, dummyCAPSEND1Click);
        CreateMenuItem(LoadAllCapSendto, planet, groupSpeed, dummyAllCAPSENDClick);
        inc(i);
      end;
    finally
      list.Free;
    end;
    LoadCapSendto1.Enabled := i <> 0;
    LoadAllCapSendto.Enabled := i <> 0;
    if listview = lvLoadedSend then begin
      LoadCAPSendto1.Enabled := (i <> 0) and isOnRoute;
      LoadAllCAPSendto.Enabled := (i <> 0) and isOnRoute;
    end;
    groupSpeed := group.EffSpeed;

    CalcDistForStock(group);

    ClearMenuItems(Sendto1);
    ClearMenuItems(SendAllto);

    list := TList.Create;
    try
      CreateDistanceList(list, SortOnArray);
      i := 0;
      while (i < list.Count) and (i < 60) do begin
        planet := TPlanet(list[i]);
        CreateMenuItem(Sendto1, planet, groupSpeed, dummySend1Click);
        CreateMenuItem(SendAllto, planet, groupSpeed, dummyAllSendClick);
        inc(i);
      end;
    finally
      list.Free;
    end;
    Sendto1.Enabled := i <> 0;
    SendAllto.Enabled := i <> 0;
    if listview = lvLoadedSend then begin
      Sendto1.Enabled := (i <> 0) and isOnRoute;
      SendAllto.Enabled := (i <> 0) and isOnRoute;
      mniUpgrade.Enabled := (i <> 0) and isOnRoute;
    end;
  end;
end;

procedure TfrmOrders.lvToDoClick(Sender: TObject);
var
  listView: TdfsExtListView;
begin
  if PageControl2.ActivePage = tshToDo then
    listView := lvToDo
  else
  if PageControl2.ActivePage = tshLoadedSend then
    listView := lvLoadedSend
  else
    Exit;

  if listView.Selected <> nil then
    frmPlanets.ShowPlanet2(TdevGroup(listView.Selected.Data).OrgGroup.Planet, true);
end;

procedure TfrmOrders.lvToDevelopClick(Sender: TObject);
begin
  if lvToDevelop.Selected <> nil then
    frmPlanets.ShowPlanet2(TPlanet(lvToDevelop.Selected.data), true);
end;

procedure TfrmOrders.lvToTransportClick(Sender: TObject);
begin
  if lvToTransport.Selected <> nil then
    frmPlanets.ShowPlanet2(TdevPlanet(lvToTransport.Selected.data).orgPlanet, true);
end;

procedure TfrmOrders.lvDevelopingClick(Sender: TObject);
begin
  if lvDeveloping.Selected <> nil then
    frmPlanets.ShowPlanet2(TdevPlanet(lvDeveloping.Selected.data).orgPlanet, true);
end;

procedure TfrmOrders.lvLoadedSendDblClick(Sender: TObject);
var
  strDest: string;
  found: integer;
begin
  if lvLoadedSend.selected <> nil then
  begin
    strDest := lvLoadedSend.selected.SubItems.Strings[3];
    if planets.Find(lowercase(strDest), Found) then
      frmPlanets.ShowPlanet2(TPlanet(planets.Objects[found]), true);
  end;
end;

procedure TfrmOrders.InsertCommand(strCommand: string);
var
  intInsertLine: integer;
  intStart, intEnd: integer;
begin
  if strCommand = '' then Exit;
  if mniAutoInsertCommands.Checked then
  begin
    intInsertLine := GetGroupOrdersInsertionPoint;
    intStart := 1;
    repeat
      intEnd := scanT(strCommand, #13#10, intStart);
      if intEnd = 0 then intEnd := Length(strCommand) + 1;
      if intStart < intEnd then begin
        Memo1.Lines.Insert(intInsertLine, copy(strCommand, intStart, intEnd - intStart));
        inc(intInsertLine);
      end;
      intStart := scannt(strCommand, #13#10, intEnd);
    until (intEnd = Length(strCommand) + 1);
  end
  else
    Clipboard.AsText := strCommand + #13#10;
end;

procedure TfrmOrders.InsertPlanetCommand(strCommand: string);
var
  intInsertLine: integer;
  intStart, intEnd: integer;
begin
  if AutoInsertPlanetCommands.Checked then
  begin
    intInsertLine := GetPlanetOrdersInsertionPoint;
    intStart := 1;
    repeat
      intEnd := scanT(strCommand, #13#10, intStart);
      if intEnd = 0 then intEnd := Length(strCommand) + 1;
      if intStart < intEnd then begin
        Memo1.Lines.Insert(intInsertLine, copy(strCommand, intStart, intEnd - intStart));
        inc(intInsertLine);
      end;
      intStart := scannt(strCommand, #13#10, intEnd);
    until (intEnd = Length(strCommand) + 1);
  end
  else
    Clipboard.AsText := strCommand + #13#10;
end;

procedure TfrmOrders.InsertOtherCommand(strCommand: string);
var
  intInsertLine: integer;
  intStart, intEnd: integer;
begin
  if AutoInsertOtherCommands.Checked then
  begin
    intInsertLine := GetOtherOrdersInsertionPoint;
    intStart := 1;
    repeat
      intEnd := scanT(strCommand, #13#10, intStart);
      if intEnd = 0 then intEnd := Length(strCommand) + 1;
      if intStart < intEnd then begin
        Memo1.Lines.Insert(intInsertLine, copy(strCommand, intStart, intEnd - intStart));
        inc(intInsertLine);
      end;
      intStart := scannt(strCommand, #13#10, intEnd);
    until (intEnd = Length(strCommand) + 1);
  end
  else
    Clipboard.AsText := strCommand + #13#10;
end;

procedure TfrmOrders.InsertRouteCommand(strCommand: string);
var
  intInsertLine: integer;
  intStart, intEnd: integer;
begin
  if AutoInsertRouteCommands.Checked then
  begin
    intInsertLine := GetRouteOrdersInsertionPoint;
    intStart := 1;
    repeat
      intEnd := scanT(strCommand, #13#10, intStart);
      if intEnd = 0 then intEnd := Length(strCommand) + 1;
      if intStart < intEnd then begin
        Memo1.Lines.Insert(intInsertLine, copy(strCommand, intStart, intEnd - intStart));
        inc(intInsertLine);
      end;
      intStart := scannt(strCommand, #13#10, intEnd);
    until (intEnd = Length(strCommand) + 1);
  end
  else
    Clipboard.AsText := strCommand + #13#10;
end;

function SearchInTStrings(strings: TStrings; strDest: string): integer;
begin
  Result := 0;
  while Result < strings.Count do
  begin
    if CompareText(strings.Strings[Result], strDest) = 0 then Exit;
    inc(Result);
  end;
  Result := -1;
end;

function TfrmOrders.GetGroupOrdersInsertionPoint: integer;
var
  i: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Group Insertion start-');
  if i = -1 then
  begin
    i := SearchInTStrings(Memo1.Lines, '#END');
    if i = -1 then
      i := Memo1.Lines.Add('#END');
    Memo1.Lines.insert(i, ';-MKGal Group Insertion start-');
  end;
  Result := SearchInTStrings(Memo1.Lines, ';-MKGal Group Insertion end-');
  while (Result <> -1) and (Result < i) do
  begin
    Memo1.Lines.Delete(Result);
    dec(i);
    Result := SearchInTStrings(Memo1.Lines, ';-MKGal Group Insertion end-');
  end;
  if Result = -1 then
  begin
    Result := i + 1;
    Memo1.Lines.insert(Result, ';-MKGal Group Insertion end-');
  end;
end;

function TfrmOrders.GetPlanetOrdersInsertionPoint: integer;
var
  i: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Planet Insertion start-');
  if i = -1 then
  begin
    i := SearchInTStrings(Memo1.Lines, '#END');
    if i = -1 then
      i := Memo1.Lines.Add('#END');
    Memo1.Lines.insert(i, ';-MKGal Planet Insertion start-');
  end;
  Result := SearchInTStrings(Memo1.Lines, ';-MKGal Planet Insertion end-');
  while (Result <> -1) and (Result < i) do
  begin
    Memo1.Lines.Delete(Result);
    dec(i);
    Result := SearchInTStrings(Memo1.Lines, ';-MKGal Planet Insertion end-');
  end;
  if Result = -1 then
  begin
    Result := i + 1;
    Memo1.Lines.insert(Result, ';-MKGal Planet Insertion end-');
  end;
end;

function TfrmOrders.GetOtherOrdersInsertionPoint: integer;
var
  i: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Other Insertion start-');
  if i = -1 then
  begin
    i := SearchInTStrings(Memo1.Lines, ';-MKGal Planet Insertion start-');
    if i = -1 then
    begin
      i := SearchInTStrings(Memo1.Lines, '#END');
      if i = -1 then
        i := Memo1.Lines.Add('#END');
    end;
    Memo1.Lines.insert(i, ';-MKGal Other Insertion start-');
  end;
  Result := SearchInTStrings(Memo1.Lines, ';-MKGal Other Insertion end-');
  while (Result <> -1) and (Result < i) do
  begin
    Memo1.Lines.Delete(Result);
    dec(i);
    Result := SearchInTStrings(Memo1.Lines, ';-MKGal Other Insertion end-');
  end;
  if Result = -1 then
  begin
    Result := i + 1;
    Memo1.Lines.insert(Result, ';-MKGal Other Insertion end-');
  end;
end;

function TfrmOrders.GetRouteOrdersInsertionPoint: integer;
var
  i: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Route Insertion start-');
  if i = -1 then
  begin
    i := SearchInTStrings(Memo1.Lines, ';-MKGal Group Insertion start-');
    if i = -1 then
    begin
      i := SearchInTStrings(Memo1.Lines, '#END');
      if i = -1 then
        i := Memo1.Lines.Add('#END');
    end;
    Memo1.Lines.insert(i, ';-MKGal Route Insertion start-');
  end;
  Result := SearchInTStrings(Memo1.Lines, ';-MKGal Route Insertion end-');
  while (Result <> -1) and (Result < i) do
  begin
    Memo1.Lines.Delete(Result);
    dec(i);
    Result := SearchInTStrings(Memo1.Lines, ';-MKGal Route Insertion end-');
  end;
  if Result = -1 then
  begin
    Result := i + 1;
    Memo1.Lines.insert(Result, ';-MKGal Route Insertion end-');
  end;
end;

procedure TfrmOrders.mniAutoInsertCommandsClick(Sender: TObject);
begin
  mniAutoInsertCommands.Checked := not mniAutoInsertCommands.Checked;
end;

procedure TfrmOrders.mniDeleteAutoInsertPlanetCommandClick(Sender: TObject);
var
  i, j: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Planet Insertion start-');
  inc(i);
  j := SearchInTStrings(Memo1.Lines, ';-MKGal Planet Insertion end-');
  while i < j do
  begin
    Memo1.Lines.Delete(i);
    dec(j);
  end;
end;

function TfrmOrders.GetFindOrdersInsertionPoint(Lines: TStrings): integer;
var
  i: integer;
begin
  i := SearchInTStrings(Lines, ';-MKGal Find Insertion start-');
  if i = -1 then
  begin
    i := SearchInTStrings(Lines, ';-MKGal Group Insertion start-');
    if i = -1 then
    begin
      i := SearchInTStrings(Lines, '#END');
      if i = -1 then
        i := Lines.Add('#END');
    end;
    Lines.insert(i, ';-MKGal Find Insertion start-');
  end;
  Result := SearchInTStrings(Lines, ';-MKGal Find Insertion end-');
  while (Result <> -1) and (Result < i) do
  begin
    Lines.Delete(Result);
    dec(i);
    Result := SearchInTStrings(Lines, ';-MKGal Find Insertion end-');
  end;
  if Result = -1 then
  begin
    Lines.insert(i + 1, ';-MKGal Find Insertion end-');
  end;
  Result := SearchInTStrings(Lines, ';-MKGal Find Insertion start-') + 1;
end;

procedure TfrmOrders.mniInsertFindCommandsClick(Sender: TObject);
var
  i, j: integer;
begin
  if inivars.Gametype in [gtGalaxyBlind, gtGalaxyNGBlind] then Exit;
  i := GetFindOrdersInsertionPoint(Memo1.Lines);
  j := SearchInTStrings(Memo1.Lines, ';-MKGal Find Insertion end-');
  while i < j do begin
    Memo1.Lines.Delete(i);
    dec(j);
  end;
  for j := 0 to players.Count - 1 do
    if (players.Objects[j] <> qReportPlayer) and
      (Tplayer(players.Objects[j]).EffIndustryCur > 0) then
      Memo1.Lines.Insert(i, 'F ' + Tplayer(players.Objects[j]).Name);
end;

procedure TfrmOrders.mniUpgradeClick(Sender: TObject);
begin
  InsertCommand('G ' + strGroup);
  AnalyseAndDoOutput;
end;

procedure TfrmOrders.lvShipsInProductionClick(Sender: TObject);
begin
  if lvShipsInProduction.selected <> nil then
    frmPlanets.ShowPlanet2(TPlanet(lvShipsInProduction.selected.Data), true);
end;

procedure TfrmOrders.mniOptionsClick(Sender: TObject);
begin
  mniExportListview.Enabled := ActiveControl is TCustomListview;
end;

procedure TfrmOrders.mniExportListviewClick(Sender: TObject);
begin
  if ActiveControl is TdfsExtListView then begin
    ExportExtListview1.Header := TTabSheet(ActiveControl.Parent).Caption;
    ExportExtListview1.Footer := frmMKGal.Caption;
    ExportExtListview1.ListView := ActiveControl as TdfsExtListView;
    ExportExtListview1.Choose;
  end;
end;

procedure CreateTmpToDoList(tmpToDoList: Tlist; blnForCap: boolean; repeatIndex: integer);
var
  i: integer;
  devGroup: TdevGroup;
  UseShip: boolean;
begin
  tmpToDoList.Clear;
  for i := 0 to devGroups.Count - 1 do begin
    devGroup := TdevGroup(devGroups[i]);
    if Assigned(devGroup) and (devGroup.devType = dtToDo) and
      Assigned(devGroup.OrgGroup) and Assigned(devGroup.OrgGroup.Planet) then begin
      if repeatIndex = 0 then begin
        if blnForCap then UseShip := devGroup.OrgGroup._Type.CargoTypes in [ctCAP, ctCAPthenCOL]
        else UseShip := devGroup.OrgGroup._Type.CargoTypes in [ctCOL, ctCOLThenCAP];
      end else begin
        if blnForCap then UseShip := devGroup.OrgGroup._Type.CargoTypes = ctCOLThenCAP
        else UseShip := devGroup.OrgGroup._Type.CargoTypes = ctCAPthenCOL;
      end;
      if UseShip then begin
        devGroup.devPlanet := FindDevPlanet(devGroup.OrgGroup.Planet);
        tmpToDoList.Add(devGroup);
      end;
    end;
  end;
end;

procedure CreateTmpDevPlanets(tmpDevPlanets: TList; blnForCap: boolean);
var
  i: integer;
  devPlanet: TdevPlanet;
begin
  tmpDevPlanets.Clear;
  for i := 0 to devPlanets.Count - 1 do begin
    devPlanet := TdevPlanet(devPlanets.Objects[i]);
    if Assigned(devPlanet) and
      ((not blnForCap and (devplanet.devCOL[1] > 0)) or
      (blnForCap and (devplanet.devCAP[1] > 0))) then
      tmpDevPlanets.Add(devplanet);
  end;
end;

procedure CreateDistanceList(list: TList; SortOnArray: TSortOnArray);
var
  i: integer;
  planet: Tplanet;
begin
  for i := 0 to planets.Count - 1 do begin
    planet := Tplanet(planets.objects[i]);
    if Assigned(planet) and (planet.Distance > 0) then
      list.Add(planet);
  end;
  CompareSortOnArray := SortOnArray;
  list.Sort(CompareTListOnSortOnArray);
end;

procedure TfrmOrders.mniAutoMaticLoadAndSendClick(Sender: TObject);
var
  toPlanet: TPlanet;
  group: TGroup;
  devGroup: TdevGroup;
  i, j: integer;
  curCOl, curCAP: single;
  blnWasSend, blnStop: boolean;
  groupSpeed: single;
  intNumber: integer;
  tmpToDoList: Tlist;
  MaxTurnsAway: integer;
  sngMaxCargoForShip, sngCOL, sngCAP, size: single;
  AutoCAPFill: integer;
  AutoCOLFill: integer;
  SortOnArray: TSortOnArray;
  list: TList;
  repeatIndex: integer;
begin
  Screen.Cursor := crHourGlass;
  try
    AutoCAPFill := frmAutoCargoSettings.CAPFill;
    AutoCOLFill := frmAutoCargoSettings.COLFill;
    SortOnArray := frmAutoCargoSettings.SortOn;
    InitBuildability;
    AnalyseerOrders(true, UseRoutesForDevelopment);
    DoOutput;
    MaxTurnsAway := frmAutoCargoSettings.MaxDistance;
    tmpToDoList := TList.Create;
    try
      for repeatIndex := 0 to 1 do begin
        repeat
          CreateTmpToDoList(tmpToDoList, false, repeatIndex);
          blnStop := true;
          if tmpToDoList.Count > 0 then begin
            tmpToDoList.Sort(CompareToDoListOnCOL);
            i := 0;
            repeat
              devGroup := TdevGroup(tmpToDoList[i]);
              group := devGroup.OrgGroup;

              if Assigned(devGroup.devPlanet) then
                curCol := devGroup.devPlanet.devCOL[0]
              else
                curCol := 0;
              blnWasSend := False;
              if (curCol > 0) then begin
                if curCol > group.EffCargo then
                  sngMaxCargoForShip := group.EffCargo
                else
                  sngMaxCargoForShip := curCol;
                CalcDistForCOL(group, sngMaxCargoForShip, AutoCOLFill);
                list := TList.Create;
                try
                  CreateDistanceList(list, SortOnArray);

                  j := 0;
                  while not blnWasSend and (j < list.Count) do begin
                    toPlanet := TPlanet(list[j]); //TPlanet(planets.objects[j]);
                    groupSpeed := group.EffSpeedLoaded;

                    if toPlanet.Distance > 0 then begin
                      if (groupSpeed > 0) and (trunc(toPlanet.Distance / (groupSpeed * 100)) < MaxTurnsAway) then begin
                        intGroupMax := devGroup.devAantal;
                        strGroup := IntToStr(group.Nr);

                        size := toPlanet.Size * AutoCOLFill / 100;
                        sngCOL := (Size - toPlanet.PopulationCur) / 8;
                        if sngCOL > curCOL then
                          sngCOL := curCOL;

                        intNumber := trunc(sngCOL / group.EffCargo) + 1;
                        LoadGroupWithAndSend(strGroup, toPlanet.Name, 'COL', intGroupMax, intNumber);
                        blnWasSend := True;
                        AnalyseerOrders(true, UseRoutesForDevelopment);
                        i := 0;
                        blnStop := False;
                      end;
                    end;
                    inc(j);
                  end;
                finally
                  list.Free;
                end;
                if not blnWasSend then inc(i);
              end
              else
                inc(i);
            until blnWasSend or (i = tmpToDoList.Count);
          end;
        until blnStop;
      // Do NOW cap
        repeat
          CreateTmpToDoList(tmpToDoList, true, repeatIndex);
          blnStop := true;
          if tmpToDoList.Count > 0 then begin
            tmpToDoList.Sort(CompareToDoListOnCAP);
            i := 0;
            repeat
              devGroup := TdevGroup(tmpToDoList[i]);
              group := devGroup.OrgGroup;

              if Assigned(devGroup.devPlanet) then curCAP := devGroup.devPlanet.devCAP[0]
              else curCAP := 0;
              blnWasSend := False;
              if (curCAP > 0) then begin
                if curCAP > group.EffCargo then
                  sngMaxCargoForShip := group.EffCargo
                else
                  sngMaxCargoForShip := curCAP;
                CalcDistForCAP(group, sngMaxCargoForShip, AutoCAPFill);

                list := TList.Create;
                try
                  CreateDistanceList(list, SortOnArray);

                  j := 0;
                  while not blnWasSend and (j < list.Count) do begin
                    toPlanet := TPlanet(list[j]);
                    groupSpeed := group.EffSpeedLoaded;
                    if toPlanet.Distance > 0 then begin
                      if (groupSpeed > 0) and (trunc(toPlanet.Distance / (groupSpeed * 100)) < MaxTurnsAway) then begin
                        intGroupMax := devGroup.devAantal;
                        strGroup := IntToStr(group.Nr);
                        size := toPlanet.Size * AutoCAPFill / 100;
                        sngCAP := (Size - toPlanet.IndustryCur);
                        if sngCAP > curCAP then
                          sngCAP := curCAP;

                        intNumber := trunc(sngCAP / group.EffCargo);
                        if intNumber = 0 then intNumber := 1;
                        LoadGroupWithAndSend(strGroup, toPlanet.Name, 'CAP', intGroupMax, intNumber);
                        blnWasSend := True;
                        AnalyseerOrders(true, UseRoutesForDevelopment);
                        i := 0;
                        blnStop := False;
                      end;
                    end;
                    inc(j);
                  end;
                finally
                  list.Free;
                end;
                if not blnWasSend then inc(i);
              end
              else
                inc(i);
            until blnWasSend or (i = tmpToDoList.Count);
          end;
        until blnStop;
      end;
    finally
      tmpToDoList.Free;
    end;
    DoAnalyseButton;

{    AnalyseerOrders(true, UseRoutesForDevelopment);
    DoOutput;}
    ShowMessage('Ready');
  finally
    Screen.cursor := crDefault;
  end;
end;

procedure TfrmOrders.AnalyseAndDoOutput;
begin
  if mniAutoInsertCommands.Checked or AutoInsertPlanetCommands.Checked or
    AutoInsertOtherCommands.Checked or AutoInsertRouteCommands.Checked then begin
    AnalyseerOrders(true, UseRoutesForDevelopment);
    DoOutput;
    GetSendedGroups;
    GetToDevelop;
    CalculateSendedShipsMass;
    frmGroups.DoRefresh;
    frmPlanetsList.DoRefresh;
    frmPlanets.DoRefresh;
    frmShipDesign.RefreshShipTypes;
    frmRoutes.DoFillLvRoutes;
  end;
end;

procedure TfrmOrders.mniAutomaticSendEmptyShipsClick(Sender: TObject);
var
  devPlanet: TdevPlanet;
  group: TGroup;
  devGroup: TdevGroup;
  i, j: integer;
  blnWasSend, blnStop: boolean;
  groupSpeed: single;
  dist: single;
  tmpToDoList: Tlist;
  tmpDevPlanets: TList;
  X, X1, Y, Y1: single;
  intNumber: integer;
  MaxTurnsAway: integer;
  repeatIndex: integer;
begin
  Screen.Cursor := crHourGlass;
  try
    InitBuildability;
    AnalyseerOrders(false, UseRoutesForDevelopment);
//    DoOutput;
    MaxTurnsAway := frmAutoCargoSettings.MaxDistance;
    tmpToDoList := TList.Create;
    tmpDevPlanets := TList.Create;
    try
      // First, keep the groups on a planet, when there will be enough stock to ship Next turn
      for repeatIndex := 0 to 1 do begin
        CreateTmpToDoList(tmpToDoList, false, repeatIndex);
        for i := 0 to tmpToDoList.Count -1 do begin
          devGroup := TdevGroup(tmpToDoList[i]);
          if Assigned(devGroup) and Assigned(devGroup.orgGroup) and
             Assigned(devGroup.orgGroup.planet) then begin
            group := devGroup.OrgGroup;
            devPlanet := FindDevPlanet(group.Planet);
            if Assigned(devPlanet) then begin
              if devplanet.devCol[1] > 0 then begin
                strGroup := IntToStr(group.Nr);
                intGroupMax := devGroup.devAantal;
                intNumber := trunc(devplanet.devCol[1] / group.EffCargo) +1;
                if intNumber < intGroupMax then
                  InsertCommand('S ' + strGroup + ' ' + group.Planet.Name + ' ' + IntToStr(intNumber) + ' ; keep group on this planet for COL next turn')
                else begin
                  InsertCommand('S ' + strGroup + ' ' + group.Planet.Name + ' ; keep group on this planet for COL next turn');
                  intNumber := intGroupMax;
                end;
                devplanet.devCol[1] := devplanet.devCol[1] - intNumber * group.EffCargo;
                if devplanet.devCol[1] < 0 then
                  devplanet.devCol[1] := 0;
              end;
            end;
          end;
        end;
        CreateTmpToDoList(tmpToDoList, true, repeatIndex);
        for i := 0 to tmpToDoList.Count -1 do begin
          devGroup := TdevGroup(tmpToDoList[i]);
          if Assigned(devGroup) and Assigned(devGroup.orgGroup) and
             Assigned(devGroup.orgGroup.planet) then begin
            group := devGroup.OrgGroup;
            devPlanet := FindDevPlanet(group.Planet);
            if Assigned(devPlanet) then begin
              if devplanet.devCap[1] > 0 then begin
                strGroup := IntToStr(group.Nr);
                intGroupMax := devGroup.devAantal;
                intNumber := trunc(devplanet.devCap[1] / group.EffCargo) +1;
                if intNumber < intGroupMax then
                  InsertCommand('S ' + strGroup + ' ' + group.Planet.Name + ' ' + IntToStr(intNumber) + ' ; keep group on this planet for CAP next turn')
                else begin
                  InsertCommand('S ' + strGroup + ' ' + group.Planet.Name + ' ; keep group on this planet for CAP next turn');
                  intNumber := intGroupMax;
                end;
                devplanet.devCap[1] := devplanet.devCap[1] - intNumber * group.EffCargo;
                if devplanet.devCap[1] < 0 then
                  devplanet.devCap[1] := 0;
              end;
            end;
          end;
        end;
      end;
      AnalyseerOrders(true, UseRoutesForDevelopment);
      for repeatIndex := 0 to 1 do begin
        repeat
          CreateTmpToDoList(tmpToDoList, false, repeatIndex);
          CreateTmpDevPlanets(tmpDevPlanets, False);
          blnStop := true;
          if (tmpToDoList.Count > 0) and (tmpDevPlanets.Count > 0) then begin
            tmpToDoList.Sort(CompareToDoListOnEffCargo);
            tmpDevPlanets.Sort(CompareDevPlanetsListOnCOL);

            i := 0;
            repeat
              devGroup := TdevGroup(tmpToDoList[i]);
              group := devGroup.OrgGroup;
              X1 := devGroup.orgGroup.Planet.X;
              Y1 := devGroup.orgGroup.Planet.Y;
              groupSpeed := group.EffSpeedLoaded;
              intGroupMax := devGroup.devAantal;
              strGroup := IntToStr(group.Nr);
              blnWasSend := False;

{              devPlanet := FindDevPlanet(group.Planet);
              if Assigned(devPlanet) then begin
                if devplanet.devCol[1] > 0 then begin
                  intNumber := trunc(devplanet.devCol[1] / group.EffCargo);
                  if intNumber = 0 then intNumber := 1;
                  if intNumber < intGroupMax then
                    InsertCommand('L ' + strGroup + ' ' + IntToStr(intNumber))
                  else
                    InsertCommand('L ' + strGroup);
                  blnWasSend := True;
                  AnalyseerOrders(false);
                  i := 0;
                end;
              end;
}
              j := 0;
              while not blnWasSend and (j < tmpDevPlanets.Count) do begin
                devPlanet := Tdevplanet(tmpDevPlanets[j]);
                X := devplanet.orgPlanet.X;
                Y := devplanet.orgPlanet.Y;
                dist := round(sqrt((X - X1) * (X - X1) + (Y - Y1) * (Y - Y1)));

                if (groupSpeed > 0) and (trunc(dist / (groupSpeed * 100)) < MaxTurnsAway) then begin
                  intNumber := trunc(devplanet.devCol[1] / group.EffCargo) + 1;
                  if intNumber < intGroupMax then
                    InsertCommand('S ' + strGroup + ' ' + devplanet.orgPlanet.Name + ' ' + IntToStr(intNumber))
                  else
                    InsertCommand('S ' + strGroup + ' ' + devplanet.orgPlanet.Name);
                  blnWasSend := True;
                  AnalyseerOrders(true, UseRoutesForDevelopment);
                  i := 0;
                  blnStop := False;
                end;
                inc(j);
              end;
              if not blnWasSend then inc(i);
            until blnWasSend or (i = tmpToDoList.Count);
          end;
        until blnStop;

        repeat
          CreateTmpToDoList(tmpToDoList, true, repeatIndex);
          CreateTmpDevPlanets(tmpDevPlanets, True);
          blnStop := true;
          if (tmpToDoList.Count > 0) and (tmpDevPlanets.Count > 0) then begin
            tmpToDoList.Sort(CompareToDoListOnEffCargo);
            tmpDevPlanets.Sort(CompareDevPlanetsListOnCAP);

            i := 0;
            repeat
              devGroup := TdevGroup(tmpToDoList[i]);
              group := devGroup.OrgGroup;
              X1 := devGroup.orgGroup.Planet.X;
              Y1 := devGroup.orgGroup.Planet.Y;
              groupSpeed := group.EffSpeedLoaded;
              intGroupMax := devGroup.devAantal;
              strGroup := IntToStr(group.Nr);
              blnWasSend := False;
              j := 0;
              while not blnWasSend and (j < tmpDevPlanets.Count) do begin
                devPlanet := Tdevplanet(tmpDevPlanets[j]);
                X := devplanet.orgPlanet.X;
                Y := devplanet.orgPlanet.Y;
                dist := round(sqrt((X - X1) * (X - X1) + (Y - Y1) * (Y - Y1)));

                if (groupSpeed > 0) and (trunc(dist / (groupSpeed * 100)) < MaxTurnsAway) then begin
                  intNumber := trunc(devplanet.devCap[1] / group.EffCargo) +1;
                  if intNumber < intGroupMax then
                    InsertCommand('S ' + strGroup + ' ' + devplanet.orgPlanet.Name + ' ' + IntToStr(intNumber))
                  else
                    InsertCommand('S ' + strGroup + ' ' + devplanet.orgPlanet.Name);
                  blnWasSend := True;
                  AnalyseerOrders(true, UseRoutesForDevelopment);
                  i := 0;
                  blnStop := False;
                end;
                inc(j);
              end;
              if not blnWasSend then inc(i);
            until blnWasSend or (i = tmpToDoList.Count);
          end;
        until blnStop;
      end;
    finally
      tmpDevPlanets.Free;
      tmpToDoList.free;
    end;
    DoAnalyseButton;
{    AnalyseerOrders(true, UseRoutesForDevelopment);
    DoOutput;}
    ShowMessage('Ready');
  finally
    Screen.cursor := crDefault;
  end;
end;

procedure TfrmOrders.mniSetupOrdersClick(Sender: TObject);
begin
  frmSetupOrders.OrdersMemo := Memo1.Lines;
  frmSetupOrders.Show;
end;

procedure TfrmOrders.mniDeleteKnownShipTypesClick(Sender: TObject);
var
  i: integer;
  strShipTypeName: string;
  CharTable: string;
  shiptype: TShipType;
begin
  i := 0;
  CharTable := BuildTable(#$A0' ');
  while i < Memo1.Lines.Count do begin
    if (Length(Memo1.Lines[i]) > 1) and ((Memo1.Lines[i][1] = 'd') or (Memo1.Lines[i][1] = 'D')) then begin
      strShipTypeName := Fetch(Memo1.Lines[i], CharTable, 2, False);
      shiptype := FindShipType(qreportplayer, strShipTypeName);
      if Assigned(shiptype) and not shiptype.IsNew then
        Memo1.Lines.Delete(i)
      else
        inc(i);
    end else
      inc(i);
  end;
end;

procedure TfrmOrders.mniAddAsDevToClipboardAllNonDevOwnedClick(
  Sender: TObject);
var
  i: integer;
  strText: string;
begin
  strText := '';
  for i := 0 to lvToDevelop.Items.Count - 1 do begin
    if not Assigned(lvDeveloping.FindCaption(0, lvToDevelop.Items[i].Caption, False, True, False)) then begin
      if strText <> '' then strText := strtext + #13#10;
      strText := strText + ';P ' + lvToDevelop.Items[i].Caption{ + #13#10'P ' + lvToDevelop.Items[i].Caption + ' ' + strProduce};
    end;
  end;
  InsertPlanetCommand(strText);
end;

procedure TfrmOrders.mniFindNextPlanetInOrdersClick(Sender: TObject);
begin
  FindNextPlanetInOrders;
end;

procedure TfrmOrders.FindNextPlanetInOrders;
var
  blnFound: boolean;
  sLine: string;
begin
  blnFound := False;
  repeat
    if (FFoundAt = Memo1.Lines.Count) then begin
      FFoundAt := 0;
      Exit;
    end;
    if scanf(Memo1.Lines[FFoundAt], FstrFind, -1) > 0 then begin
      sLine := Memo1.Lines[FFoundAt];
      if sLine <> '' then
      begin
        if sLine[1] = ';' then sLine := trim(copy(sLine, 2, length(sLine)));
        if Assigned(GetPlanetFromOrderLine(sLine)) then begin
          Show;
          Memo1.SetFocus;
          Memo1.CaretX := 1;
          Memo1.CaretY := FFoundAt + 1;
          Memo1.EnsureCursorPosVisible;
          blnFound := True;
        end;
      end;
    end;
    inc(FFoundAt);
  until blnFound;
end;

procedure TfrmOrders.mniFindPlanetInOrdersClick(Sender: TObject);
begin
  if InputQuery('Find Planet', 'Planet name:', FstrFind) then begin
    FindFirstPlanetInOrders(FstrFind);
  end;
end;

procedure TfrmOrders.FindFirstPlanetInOrders(PlanetName: string);
begin
  FFoundAt := 1;
  FstrFind := PlanetName;
  FindNextPlanetInOrders;
end;

procedure TfrmOrders.lvDevelopingDblClick(Sender: TObject);
begin
  if lvDeveloping.Selected <> nil then
    FindFirstPlanetInOrders(TdevPlanet(lvDeveloping.Selected.data).orgPlanet.Name);
end;

procedure TfrmOrders.lvToTransportDblClick(Sender: TObject);
begin
  if lvToTransport.Selected <> nil then
    FindFirstPlanetInOrders(TdevPlanet(lvToTransport.Selected.data).orgPlanet.Name);
end;

procedure TfrmOrders.lvToDevelopDblClick(Sender: TObject);
begin
  if lvToDevelop.Selected <> nil then
    FindFirstPlanetInOrders(TdevPlanet(lvToDevelop.Selected.data).orgPlanet.Name);
end;

procedure TfrmOrders.lvShipsInProductionDblClick(Sender: TObject);
begin
  if lvShipsInProduction.selected <> nil then
    FindFirstPlanetInOrders(TPlanet(lvShipsInProduction.selected.Data).Name);
end;

procedure TfrmOrders.mniChangeNameClick(Sender: TObject);
var
  strRacename: string;
  index: integer;
begin
  strRacename := qReportplayer.Name;
  if Inputquery('Create Order', 'Enter new race name', strRacename) then begin
    for index := 0 to players.Count - 1 do
      if CompareText(strRacename, players[index]) = 0 then begin
        ShowMessage('Player Name already used!');
        Exit;
      end;
    InsertOtherCommand('C ' + strRacename);
  end;
end;

procedure TfrmOrders.mniQuitGameClick(Sender: TObject);
begin
  if Question('Are you sure to quit?') then
    InsertOtherCommand('Q ' + qReportplayer.Name);
end;

procedure TfrmOrders.DecrementTurnCounter1Click(Sender: TObject);
var
  i: integer;
  iPos: integer;
  strVoor: string;
  intRest: integer;
begin
  for i := 0 to memo1.Lines.Count - 1 do begin
    if (pos('; t', memo1.Lines[i]) > 0) or
      (pos(';t', memo1.Lines[i]) > 0) then begin
      iPos := pos('; t', memo1.Lines[i]);
      if iPos < 1 then
        iPos := pos(';t', memo1.Lines[i]);
      strVoor := copy(memo1.Lines[i], 1, iPos);
      intRest := mkAtoI(copy(memo1.Lines[i], iPos, Length(memo1.Lines[i])));
      if intRest > 1 then memo1.Lines[i] := strVoor + ' t' + mkItoA(intRest - 1)
      else memo1.Lines[i] := strVoor + ' t &';
    end;
  end;
end;

procedure TfrmOrders.DevelopStdShiptypeOnthisPlanet1Click(Sender: TObject);
var
  planet: Tplanet;
  strCommand: string;
begin
  strCommand := '';
  planet := GetPlanetAtCurrentPosLine;
  if Assigned(planet) then begin
    if not (planet.PlayerCur = qReportPlayer) then Exit;
    if (planet.EffMassProduceCur < 2) then exit;
    frmShipDesign.SetBaseMass(planet.EffMassProduceCur);
    frmShipDesign.CalculateStdShip;
    if not Assigned(FindShipType(qreportplayer, frmShipDesign.FStdShipName)) then
      strCommand := frmShipDesign.FStdShip + #13#10;
    strCommand := strCommand +
      'P ' + planet.Name + ' ' + frmShipDesign.FStdShipName +
      ' ; t' + frmShipDesign.GetUsedTurns + #13#10;
    InsertPlanetCommand(strCommand);
  end;
end;

procedure TfrmOrders.SpeedItem1Click(Sender: TObject);
begin
  frmstdShip.SpeedIndex := TMenuItem(Sender).MenuIndex;
end;

procedure TfrmOrders.WeaponsItem1Click(Sender: TObject);
begin
  frmstdShip.WeaponsIndex := TMenuItem(Sender).MenuIndex;
end;

procedure TfrmOrders.ShieldsItem1Click(Sender: TObject);
begin
  frmstdShip.ShieldsIndex := TMenuItem(Sender).MenuIndex;
end;

procedure TfrmOrders.DefaultSpeed1Click(Sender: TObject);
begin
  DefaultSpeed1.Items[frmStdShip.SpeedIndex].Checked := True;
end;

procedure TfrmOrders.DefaultWeapons1Click(Sender: TObject);
begin
  DefaultWeapons1.Items[frmStdShip.WeaponsIndex].Checked := True;
end;

procedure TfrmOrders.DefaultShields1Click(Sender: TObject);
begin
  DefaultShields1.Items[frmStdShip.ShieldsIndex].Checked := True;
end;

procedure TfrmOrders.DefaultUseTurns1Click(Sender: TObject);
begin
  try
    DefaultUseTurns1.Items[mkAtoI(frmShipDesign.GetUsedTurns) - 1].Checked := True;
  except
    DefaultUseTurns1.Items[0].Checked := True;
    frmShipDesign.SetUsedTurns('1');
  end;
end;

procedure TfrmOrders.DefaultUseTurnsItemsClick(Sender: TObject);
begin
  frmShipDesign.SetUsedTurns(TMenuItem(Sender).Caption);
end;

procedure TfrmOrders.mniAllAboveClick(Sender: TObject);
begin
  Memo1.Lines.BeginUpdate;
  try
    DeleteAutoInsertGroupCommands1Click(Sender);
    mniDeleteAutoInsertPlanetCommandClick(Sender);
    DeleteAutoInsertOtherCommands1Click(Sender);
    DeleteAutoInsertRouteCommandsClick(Sender);
    DoAnalyseButton;
    CalculateSendedShipsMass;
    mniInsertFindCommandsClick(Sender);
    mniDeleteKnownShipTypesClick(Sender);
    DecrementTurnCounter1Click(Sender);
  finally
    Memo1.Lines.EndUpdate;
  end;
end;

procedure TfrmOrders.CalculateSendedShipsMass;
var
  i: integer;
  planet: TPlanet;
  SendedGroup: TSendedGroup;
begin
  for i := 0 to planets.count - 1 do begin
    planet := TPlanet(planets.Objects[i]);
    planet.SendedShipMass := 0;
    planet.SendedShipMassETA2 := 0;
    planet.SendedShipMassETA2Plus := 0;
  end;
  for i := 0 to SendedGroups.Count - 1 do begin
    SendedGroup := TSendedGroup(SendedGroups.Objects[i]);
    planet := SendedGroup.sendTo;
    if Assigned(planet) then
      case SendedGroup.ETA of
        1: planet.SendedShipMass := planet.SendedShipMass +
          SendedGroup.sendAantal * SendedGroup.orgGroup._Type.Mass;
        2: planet.SendedShipMassETA2 := planet.SendedShipMassETA2 +
          SendedGroup.sendAantal * SendedGroup.orgGroup._Type.Mass;
      else
        planet.SendedShipMassETA2Plus := planet.SendedShipMassETA2Plus +
          SendedGroup.sendAantal * SendedGroup.orgGroup._Type.Mass;
      end;
  end;
end;

procedure TfrmOrders.CompleteFillPlanetwithCAP1Click(Sender: TObject);
begin
  TMenuItem(Sender).Checked := True;
end;

function TfrmOrders.TurnTagLine: integer;
begin
  Result := 0;
  while Result < Memo1.Lines.Count do
    if pos(';MKGAL TURN', Memo1.Lines[Result]) = 1 then Exit
    else inc(Result);
  Result := -1;
end;

function TfrmOrders.FindTurnTag: integer;
var
  i: integer;
begin
  i := TurnTagLine;
  if i = -1 then begin
    Result := -1;
    Exit;
  end;
  Result := mkAtoI(Memo1.Lines[i]);
end;

procedure TfrmOrders.SetTurnTag(turn: integer);
var
  i: integer;
begin
  i := TurnTagLine;
  if i = -1 then begin
    InsertCommand(';MKGAL TURN ' + mkIToA(turn));
    Exit;
  end;
  Memo1.Lines[i] := ';MKGAL TURN ' + mkIToA(turn);
end;

procedure TfrmOrders.FindFirstGroupInOrders(GroupNr: string);
begin
  FGroupFoundAt := 1;
  FstrGroupFind := GroupNr;
  FindNextGroupInOrders;
end;

procedure TfrmOrders.FindNextGroupInOrders;
var
  blnFound: boolean;
  startOfLine, endOfLine: integer;
  sLine: string;
  group: Tgroup;
begin
  blnFound := False;
  repeat
    //FGroupFoundAt := memo1.FindText(FstrGroupFind, FGroupFoundAt, Length(memo1.Text), [stWholeWord]);
    FGroupFoundAt := scanf(Memo1.Text, FstrGroupFind, -FGroupFoundAt);
    if FGroupFoundAt > 0 then begin
      startOfLine := scanb(Memo1.Text, #10, FGroupFoundAt);
      if startOfLine < 1 then startOfLine := 1;
      inc(startOfLine);
      endOfLine := scanc(Memo1.Text, #13, FGroupFoundAt);
      if endOfLine > Length(Memo1.Text) then endOfLine := Length(Memo1.Text);
      sLine := copy(memo1.text, StartOfLine, EndOfLine - StartOfLine);
      if sLine <> '' then
      begin
        if sLine[1] = ';' then sLine := trim(copy(sLine, 2, length(sLine)));
        group := GetGroupFromOrderLine(sLine);
        if Assigned(group) and (StrToInt(FstrGroupFind) = group.Nr) then begin
          Show;
          Memo1.SetFocus;
          Memo1.SetSelStart(FGroupFoundAt);
          Memo1.SetSelEnd(FGroupFoundAt + Length(FstrGroupFind));
          blnFound := True;
        end;
      end;
      inc(FGroupFoundAt);
    end else exit;
  until blnFound;
end;

function TfrmOrders.GetGroupAtCurrentPosLine: TGroup;
var
  PointedAt: integer;
  startOfLine: integer;
  endOfLine: integer;
  sLine: string;
begin
  Result := nil;
  PointedAt := Memo1.GetSelStart;
  startOfLine := scanb(Memo1.Text, #10, PointedAt);
  if startOfLine < 1 then startOfLine := 0;
  inc(startOfLine);
  endOfLine := scanc(Memo1.Text, #13, PointedAt);
  if endOfLine > Length(Memo1.Text) then endOfLine := Length(Memo1.Text);
  sLine := copy(memo1.text, StartOfLine, EndOfLine - StartOfLine);
  if sLine <> '' then
  begin
    if sLine[1] = ';' then sLine := trim(copy(sLine, 2, length(sLine)));
    Result := GetGroupFromOrderLine(sLine);
  end;
end;

procedure TfrmOrders.FindGroupinOrders1Click(Sender: TObject);
begin
  if InputQuery('Find Group', 'Group nr:', FstrGroupFind) then begin
    FindFirstGroupInOrders(FstrGroupFind);
  end;
end;

procedure TfrmOrders.FindNextGroupinOrders1Click(Sender: TObject);
begin
  FindNextGroupinOrders;
end;

procedure TfrmOrders.ReplaceProductionType1Click(Sender: TObject);
const
  strProduce: string = '';
var
  SelStart, SelEnd: integer;
  sLine: string;
  startOfLine, endOfLine: integer;
  orgLenght, newLenght: integer;
  planet: TPlanet;
begin
  //SelStart := Memo1.SelStart;
  //SelEnd := SelStart + memo1.SelLength;
  SelStart := Memo1.GetSelStart;
  SelEnd := Memo1.GetSelEnd;

  if GetProduceItem(strProduce) then begin
    while SelStart <= SelEnd do begin
      startOfLine := scanb(Memo1.Text, #10, SelStart);
      if startOfLine < 1 then startOfLine := 1;
      inc(startOfLine);
      endOfLine := scanc(Memo1.Text, #13, SelStart);
      if endOfLine > Length(Memo1.Text) then
        endOfLine := Length(Memo1.Text);
      sLine := copy(memo1.text, StartOfLine, EndOfLine - StartOfLine);
//      dec(StartOfLine);
      if sLine <> '' then begin
        if (sLine[1] = 'p') or (sLine[1] = 'P') then begin
          planet := GetPlanetFromOrderLine(sLine);
          if Assigned(planet) then begin
            orgLenght := Length(sLine);
            sLine := 'P ' + planet.Name + ' ' + strProduce;
           // Memo1.SelStart := StartOfLine;
           // Memo1.SelLength := orgLenght;
           // Memo1.SelText := sLine;
            Memo1.SetSelStart(StartOfLine);
            Memo1.SetSelEnd(StartOfLine + orgLenght);
            Memo1.SelText := sLine;
            SelEnd := SelEnd - orgLenght + Length(sLine);
          end;
        end;
      end;
      newLenght := Length(sLine);
      SelStart := startOfLine + newLenght + 2;
    end;
    DoAnalyseButton;
  end;
end;

procedure TfrmOrders.ReplaceProductionTypeToStandardShip1Click(
  Sender: TObject);
var
  SelStart, SelEnd: integer;
  sLine: string;
  startOfLine, endOfLine: integer;
  orgLenght, newLenght: integer;
  planet: TPlanet;
  stList: TStringList;
begin
  //SelStart := Memo1.SelStart;
  //SelEnd := SelStart + memo1.SelLength;
  SelStart := Memo1.GetSelStart;
  SelEnd := Memo1.GetSelEnd;
  stList := TStringList.Create;
  try
    while SelStart <= SelEnd do begin
      startOfLine := scanb(Memo1.Text, #10, SelStart);
      if startOfLine < 1 then startOfLine := 1;
      inc(startOfLine);
      endOfLine := scanc(Memo1.Text, #13, SelStart);
      if endOfLine > Length(Memo1.Text) then
        endOfLine := Length(Memo1.Text);
      sLine := copy(memo1.text, StartOfLine, EndOfLine - StartOfLine);
//      dec(StartOfLine);
      if sLine <> '' then begin
        if (sLine[1] = 'p') or (sLine[1] = 'P') then begin
          planet := GetPlanetFromOrderLine(sLine);
          if Assigned(planet) and (planet.EffMassProduceCur >= 2) and
            (planet.PlayerCur = qReportPlayer) then begin
            orgLenght := Length(sLine);

            frmShipDesign.SetBaseMass(planet.EffMassProduceCur);
            frmShipDesign.CalculateStdShip;
            if not Assigned(FindShipType(qreportplayer, frmShipDesign.FStdShipName)) and
              (stList.IndexOf(frmShipDesign.FStdShipName) = -1) then begin
              sLine := frmShipDesign.FStdShip + #13#10;
              stList.Add(frmShipDesign.FStdShipName);
            end else
              sLine := '';

            sLine := sLine +
              'P ' + planet.Name + ' ' + frmShipDesign.FStdShipName +
              ' ; t' + frmShipDesign.GetUsedTurns;

//            Memo1.SelStart := StartOfLine;
//            Memo1.SelLength := orgLenght;
            Memo1.SetSelStart(StartOfLine);
            Memo1.SetSelEnd(StartOfLine + orgLenght);
            Memo1.SelText := sLine;
            SelEnd := SelEnd - orgLenght + Length(sLine);
          end;
        end;
      end;
      newLenght := Length(sLine);
      SelStart := startOfLine + newLenght + 2;
    end;
    DoAnalyseButton;
  finally
    stList.Free;
  end;
end;

procedure TfrmOrders.Cut1Click(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

procedure TfrmOrders.Copy1Click(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

procedure TfrmOrders.Paste1Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TfrmOrders.PopupMenu1Popup(Sender: TObject);
begin
  //Cut1.Enabled := Memo1.SelLength > 0;
  Cut1.Enabled := Memo1.SelAvail;
  Copy1.Enabled := Cut1.Enabled;
  Paste1.Enabled := ClipBoard.HasFormat(CF_TEXT);

  ChangePassword1.Visible := inivars.Gametype = gtGalaxyNG;
end;

procedure TfrmOrders.Settings1Click(Sender: TObject);
begin
  frmAutoCargoSettings.ShowModal;
end;

procedure TfrmOrders.DeleteAutoInsertGroupCommands1Click(Sender: TObject);
var
  i, j: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Group Insertion start-');
  inc(i);
  j := SearchInTStrings(Memo1.Lines, ';-MKGal Group Insertion end-');
  while i < j do
  begin
    Memo1.Lines.Delete(i);
    dec(j);
  end;
end;

procedure TfrmOrders.AutoInsertPlanetCommandsClick(Sender: TObject);
begin
  AutoInsertPlanetCommands.Checked := not AutoInsertPlanetCommands.Checked;
end;

procedure TfrmOrders.AutoInsertOtherCommandsClick(Sender: TObject);
begin
  AutoInsertOtherCommands.Checked := not AutoInsertOtherCommands.Checked;
end;

procedure TfrmOrders.Changeemailadress1Click(Sender: TObject);
var
  strNewAdress: string;
begin
  strNewAdress := '';
  if Inputquery('Create Order', 'Enter new email adress', strNewAdress) then begin
    InsertOtherCommand('Z ' + strNewAdress);
  end;
end;

procedure TfrmOrders.ChangePassword1Click(Sender: TObject);
var
  strNewPassword: string;
begin
  strNewPassword := '';
  if Inputquery('Create Order', 'Enter new password', strNewPassword) then begin
    InsertOtherCommand('Y ' + strNewPassword);
  end;
end;

procedure TfrmOrders.DeleteAutoInsertOtherCommands1Click(Sender: TObject);
var
  i, j: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Other Insertion start-');
  inc(i);
  j := SearchInTStrings(Memo1.Lines, ';-MKGal Other Insertion end-');
  while i < j do
  begin
    Memo1.Lines.Delete(i);
    dec(j);
  end;
end;

procedure TfrmOrders.SaveordersCRonly1Click(Sender: TObject);
var
  strOrders: string;
begin
  if SaveDialog1.Execute then
  begin
    strOrders := Memo1.Lines.GetText;
    DeleteC(strOrders, #10);
    strFileSave(SaveDialog1.FileName, strOrders);
    Application.MessageBox(PChar(STxtMesSaved), PChar(StitMesSaved), MB_OK);
  end;
end;

procedure TfrmOrders.SaveordersLFonly1Click(Sender: TObject);
var
  strOrders: string;
begin
  if SaveDialog1.Execute then
  begin
    strOrders := Memo1.Lines.GetText;
    DeleteC(strOrders, #13);
    strFileSave(SaveDialog1.FileName, strOrders);
    Application.MessageBox(PChar(STxtMesSaved), PChar(StitMesSaved), MB_OK);
  end;
end;

procedure TfrmOrders.DeleteAutoInsertRouteCommandsClick(Sender: TObject);
var
  i, j: integer;
begin
  i := SearchInTStrings(Memo1.Lines, ';-MKGal Route Insertion start-');
  inc(i);
  j := SearchInTStrings(Memo1.Lines, ';-MKGal Route Insertion end-');
  while i < j do
  begin
    Memo1.Lines.Delete(i);
    dec(j);
  end;
end;

procedure TfrmOrders.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FFoundAt := Memo1.CaretY -1;
  FGroupFoundAt := Memo1.CaretY -1;
end;

procedure TfrmOrders.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F5) or (Key = VK_F6) then
    DoAnalyseButton;
end;

procedure TfrmOrders.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F3 then FindNextPlanetInOrders;
  if Key = VK_F4 then FindNextGroupInOrders;
end;

function TfrmOrders.GetUseRoutesForDevelopment: boolean;
begin
  Result := UseRoutesForDevelopment1.Checked;
end;

procedure TfrmOrders.SetUseRoutesForDevelopment(const Value: boolean);
begin
  UseRoutesForDevelopment1.Checked := Value;
end;

procedure TfrmOrders.GetSendedGroupsOnRoutes;
var
  i: integer;
  SendedGroup: TSendedGroup;

  devGroup: TdevGroup;
  distance: single;

  vX1: Single;
  vY1: Single;
  vX2: Single;
  vY2: Single;
begin
  for i := 0 to devGroups.Count -1 do begin
    devGroup := TdevGroup(devGroups[i]);
    if Assigned(devGroup) then begin
      if (devGroup.devType = dtOnRoute) then begin
        SendedGroup := FindSendedGroup(devGroup.orgGroup.Nr);

        if Assigned(SendedGroup) then begin
          if (devGroup.devAantal < SendedGroup.sendAantal) then
            BreakSendedGroup(SendedGroup, devGroup.devAantal);
          SendedGroup.sendTo := devGroup.PlanetDest;
          SendedGroup.sendFrom := devGroup.orgGroup.planet;
          SendedGroup.sendQuantity := devGroup.devQuantity;
          SendedGroup.sendCargoType := devGroup.devLoadedWith;
                vX1 := SendedGroup.sendTo.x;
                vY1 := SendedGroup.sendTo.y;
                vX2 := SendedGroup.sendFrom.x;
                vY2 := SendedGroup.sendFrom.y;
          distance := round(sqrt((vX1 - vX2) * (vX1 - vX2) +
                    (vY1 - vY2) * (vY1 - vY2))) / 100;

          SendedGroup.sendToGo := distance;
          if (distance > 0) and (SendedGroup.GetSpeed > 0) then
            SendedGroup.ETA := trunc(distance / SendedGroup.GetSpeed) + 1
          else
            SendedGroup.ETA := 0;
        end;
      end else begin
        if (devGroup.devType = dtLoadedSend) then begin
          SendedGroup := FindSendedGroup(devGroup.orgGroup.Nr);
          while Assigned(SendedGroup) do begin
            if SendedGroup.sendTo = devGroup.PlanetDest then begin
              SendedGroup.sendQuantity := devGroup.devQuantity;
              SendedGroup.sendCargoType := devGroup.devLoadedWith;
              if (devGroup.devToGo[0] > 0) and (SendedGroup.GetSpeed > 0) then
                SendedGroup.ETA := trunc(devGroup.devToGo[0] / SendedGroup.GetSpeed) + 1
              else
                SendedGroup.ETA := 0;
              break;
            end;
            FindNextSendedGroup(SendedGroup, devGroup.orgGroup.Nr);
          end;
{          if Assigned(SendedGroup) then
            if SendedGroup.sendTo = devGroup.PlanetDest then begin
              SendedGroup.sendQuantity := devGroup.devQuantity;
              SendedGroup.sendCargoType := devGroup.devLoadedWith;
            end;}
        end;
      end;
    end;
  end;
end;

procedure TfrmOrders.UseRoutesForDevelopment1Click(Sender: TObject);
begin
  UseRoutesForDevelopment1.Checked := not UseRoutesForDevelopment1.Checked;
end;

procedure TfrmOrders.lvLoadedSendDrawItem(Control: TWinControl;
  var ACanvas: TCanvas; Index: Integer; ARect: TRect;
  State: TOwnerDrawState; var DefaultDrawing, FullRowSelect: Boolean);
begin
  if Assigned(lvLoadedSend.Items[Index].Data) then begin
    case TdevGroup(lvLoadedSend.Items[Index].Data).devType of
      dtLoadedSend: ACanvas.Font.Color := clBlack;
      dtOnRoute: ACanvas.Font.Color := clRed;
    end
  end;
  DefaultDrawing := true;
end;

procedure TfrmOrders.FindRenameOrders(aRenameplanetsList: TStrings);
var
  i, index: integer;
  vString: string;
begin
  for i := 0 to Memo1.Lines.Count -1 do begin
    if (Length(Memo1.Lines[i]) > 0)
       and ((Memo1.Lines[i][1] = 'N') or (Memo1.Lines[i][1] = 'n')) then begin
         index := 1;
         vString := ParseWord(Memo1.Lines[i], ' '#$A0#9, index);
         if index > 0 then begin
           vString := ParseWord(Memo1.Lines[i], ' '#$A0#9, index);
           if index > 0 then begin
             vString := ParseWord(Memo1.Lines[i], ' '#$A0#9, index);
             if vString <> '' then begin
               aRenameplanetsList.add(vString);
             end;
           end;
         end;
       end;
  end;
end;

end.

