unit UfrmWait;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TfrmWait = class(TForm)
    Label1: TLabel;
    Animate1: TAnimate;
    lblCurrentWork: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    FTitle: string;
    FCurrentWork: string;
    procedure SetTitle(value: string);
    procedure SetCurrentWork(const Value: string);
    { Private declarations }
  public
    property Title: string read FTitle write SetTitle;
    property CurrentWork: string read FCurrentWork write SetCurrentWork;
    { Public declarations }
  end;

var
  frmWait: TfrmWait;

implementation

{$R *.DFM}

procedure TfrmWait.SetTitle(value: string);
begin
  if value <> FTitle then
  begin
    Caption := value;
    FTitle := value;
  end;
end;

procedure TfrmWait.FormShow(Sender: TObject);
begin
  lblCurrentWork.Caption := 'Initializing';
  try
    Animate1.Active := True;
  except
    ;
  end;
end;

procedure TfrmWait.FormHide(Sender: TObject);
begin
  Animate1.Active := False;
end;

procedure TfrmWait.SetCurrentWork(const Value: string);
begin
  FCurrentWork := Value;
  lblCurrentWork.Caption := Value;
  Update;
  Application.ProcessMessages;
end;

end.
