program MKGal;

uses
//  HVest,
//  HVDumpExceptToFile,
  Forms,
  Esbmaths,
  SysUtils,
  UfrmMain in 'UfrmMain.pas' {frmMKGal},
  Utypes in 'Utypes.pas',
  UFiles in 'UFiles.pas',
  UfrmPlayers in 'UfrmPlayers.pas' {frmPlayers},
  UfrmPlanets in 'UfrmPlanets.pas' {frmPlanets},
  UfrmWait in 'UfrmWait.pas' {frmWait},
  UfrmBattles in 'UfrmBattles.pas' {frmBattles},
  UfrmShipDesign in 'UfrmShipDesign.pas' {frmShipDesign},
  UfrmGraph in 'UfrmGraph.pas' {frmGraph},
  UfrmBattleSimulator in 'UfrmBattleSimulator.pas' {frmBattleSimulator},
  UBatSim2 in 'UBatSim2.pas',
  UfrmOrders in 'UfrmOrders.pas' {frmOrders},
  UDevelop in 'UDevelop.pas',
  UfrmIncomingGroups in 'UfrmIncomingGroups.pas' {frmIncomingGroups},
  UfrmPlanetSelect in 'UfrmPlanetSelect.pas' {frmPlanetSelect},
  UfrmTurnReports in 'UfrmTurnReports.pas' {frmTurnReports},
  UfrmStdShip in 'UfrmStdShip.pas' {frmStdShip},
  UfrmCalculate in 'UfrmCalculate.pas' {frmCalculate},
  UfrmAbout in 'UfrmAbout.pas' {frmAbout},
  UfrmSetExtraInfo in 'UfrmSetExtraInfo.pas' {frmSetExtraInfo},
  UfrmBombings in 'UfrmBombings.pas' {frmBombings},
  UfrmConfigIni in 'UfrmConfigIni.pas' {frmConfigIni},
  UfrmGroupFilter in 'UfrmGroupFilter.pas' {frmGroupFilter},
  UFilesCountMethod in 'UFilesCountMethod.pas',
  UAddTabs in 'UAddTabs.pas',
  USortingAlgorithems in 'USortingAlgorithems.pas',
  UfrmSetupOrders in 'UfrmSetupOrders.pas' {frmSetupOrders},
  UfrmNewMap in 'UfrmNewMap.pas' {frmNewMap},
  UExportToMDB in 'UExportToMDB.pas',
  DAO_TLB in 'DAO_TLB.pas',
  UfrmExpressionFilters in 'UfrmExpressionFilters.pas' {frmExpressionFilters},
  UfrmGroups in 'UfrmGroups.pas' {frmGroups},
  UfrmSelectExpression in 'UfrmSelectExpression.pas' {frmSelectExpressions},
  UfrmPlanetslist in 'UfrmPlanetslist.pas' {frmPlanetslist},
  UAdvancedSend in 'UAdvancedSend.pas' {frmAdvancedSend},
  UfrmCalculations in 'UfrmCalculations.pas' {frmCalculations},
  UfrmAutoCargoSettings in 'UfrmAutoCargoSettings.pas' {frmAutoCargoSettings},
  UfrmCreateMessage in 'UfrmCreateMessage.pas' {frmCreateMessage},
  UmkStrParse in 'UmkStrParse.pas',
  UfrmRoutes in 'UfrmRoutes.pas' {frmRoutes},
  UFastLists in 'UFastLists.pas',
  UDistLists in 'UDistLists.pas',
  UfrmOverView in 'UfrmOverView.pas' {frmOverView},
  UfrmChangeColors in 'UfrmChangeColors.pas' {frmChangeColors},
  UfrmChangePlayerColors in 'UfrmChangePlayerColors.pas' {frmChangePlayerColors},
  UfrmEditor in 'UfrmEditor.pas' {frmEditor},
  UmkListviewExport in '..\..\Delphi\Components\mkListview\UmkListviewExport.pas';

{$R *.RES}

{$IFDEF BindingRTLI}
{$R *.RLI}
{$ENDIF}

begin
  //Set87ControlWord(Get87ControlWord and $F7FF);
  Application.Initialize;
  Application.Title := 'MKGal';
  Application.CreateForm(TfrmMKGal, frmMKGal);
  Application.CreateForm(TfrmPlayers, frmPlayers);
  Application.CreateForm(TfrmPlanets, frmPlanets);
  Application.CreateForm(TfrmWait, frmWait);
  Application.CreateForm(TfrmBattles, frmBattles);
  Application.CreateForm(TfrmShipDesign, frmShipDesign);
  Application.CreateForm(TfrmGraph, frmGraph);
  Application.CreateForm(TfrmBattleSimulator, frmBattleSimulator);
  Application.CreateForm(TfrmOrders, frmOrders);
  Application.CreateForm(TfrmIncomingGroups, frmIncomingGroups);
  Application.CreateForm(TfrmNewMap, frmNewMap);
  Application.CreateForm(TfrmPlanetSelect, frmPlanetSelect);
  Application.CreateForm(TfrmTurnReports, frmTurnReports);
  Application.CreateForm(TfrmAbout, frmAbout);
  Application.CreateForm(TfrmBombings, frmBombings);
  Application.CreateForm(TfrmConfigIni, frmConfigIni);
  Application.CreateForm(TfrmSetupOrders, frmSetupOrders);
  Application.CreateForm(TfrmGroups, frmGroups);
  Application.CreateForm(TfrmSelectExpressions, frmSelectExpressions);
  Application.CreateForm(TfrmPlanetslist, frmPlanetslist);
  Application.CreateForm(TfrmCalculations, frmCalculations);
  Application.CreateForm(TfrmAutoCargoSettings, frmAutoCargoSettings);
  Application.CreateForm(TfrmCreateMessage, frmCreateMessage);
  Application.CreateForm(TfrmRoutes, frmRoutes);
  Application.CreateForm(TfrmOverView, frmOverView);
  Application.CreateForm(TfrmChangePlayerColors, frmChangePlayerColors);
  Application.CreateForm(TfrmEditor, frmEditor);
  frmWait.Show;
  frmWait.Repaint;
  if ReadMKGalIni and ReadReports then
  begin
    Application.CreateForm(TfrmSetExtraInfo, frmSetExtraInfo);
    Application.CreateForm(TfrmGroupFilter, frmGroupFilter);
//    Application.CreateForm(TfrmPlanetFilter, frmPlanetFilter);
    Application.CreateForm(TfrmExpressionFilters, frmExpressionFilters);
    Application.CreateForm(TfrmChangeColors, frmChangeColors);
    frmWait.Hide;
    Application.Run;
  end else begin
    frmWait.Hide;
    frmConfigIni.OvcFormState1.Active := False;
    frmConfigIni.WindowState := wsNormal;
    frmConfigIni.ShowModal;
    Application.Terminate;
    Application.ShowHint := False;
    Application.Destroying;
    Application.DestroyComponents;
  end;
end.

