unit UfrmCreateMessage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, RzDlgBtn, StdCtrls;

type
  TfrmCreateMessage = class(TForm)
    RzDialogButtons1: TRzDialogButtons;
    Memo1: TMemo;
  private
    FSendTo: string;
    procedure SetSendTo(const Value: string);
    function GetMessage: string;
    { Private declarations }
  public
    property SendTo: string read FSendTo write SetSendTo;
    property StrMessage: string read GetMessage;
    { Public declarations }
  end;

var
  frmCreateMessage: TfrmCreateMessage;

implementation

{$R *.DFM}

{ TfrmCreateMessage }

function TfrmCreateMessage.GetMessage: string;
begin
  Result := '@ ' + FSendTo + #13#10 + Memo1.Lines.GetText + #13#10 + '@';
end;

procedure TfrmCreateMessage.SetSendTo(const Value: string);
begin
  FSendTo := Value;
  if Value = '' then
    Caption := 'Create Global Message'
  else
    Caption := 'Create Message for ' + Value;
end;

end.
