unit UfrmPlanets;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, Utypes, Menus,
  RzLstBox, OvcState, OvcBase, EC_Main,
  RzCommon, RzLookup, TopWnd, SysMenu, mkListView,
  UmkListviewExport, EnhListView, ExtListView;

type
  TfrmPlanets = class(TForm)
    Planets_InfoPanel: TPanel;
    Splitter2: TSplitter;
    PlanetsPanel: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Splitter1: TSplitter;
    Panel6: TPanel;
    Panel7: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    lbxInfo: TRzTabbedListBox;
    ShipsPopup: TPopupMenu;
    AddToDefender1: TMenuItem;
    AddToAttacker1: TMenuItem;
    cbxGroupFilterOn: TCheckBox;
    planetsPopup: TPopupMenu;
    N1: TMenuItem;
    SendGroupsto1: TMenuItem;
    SendGrouptoplanets1: TMenuItem;
    Button1: TButton;
    btnSetExtraInfo: TButton;
    mniUpgrade: TMenuItem;
    cbxGroupFilterInversed: TCheckBox;
    btnGroupFilter: TButton;
    OvcFormState1: TOvcFormState;
    OvcComponentState1: TOvcComponentState;
    mniExportAllPlanets: TMenuItem;
    mniExportSelectedplanets: TMenuItem;
    N2: TMenuItem;
    mniAddToClipboardAsDevPlanets: TMenuItem;
    mniAddToClipboardAsPlanetstoProduce: TMenuItem;
    RzLookupDialog1: TRzLookupDialog;
    btnExpressionFilter: TButton;
    SystemMenu1: TSystemMenu;
    TopMostWindow1: TTopMostWindow;
    PlanetSysMenu: TPopupMenu;
    mniTopMost: TMenuItem;
    mniFindPlanetInOrders: TMenuItem;
    N3: TMenuItem;
    FindPlanetinOrders1: TMenuItem;
    N4: TMenuItem;
    MapMenu: TPopupMenu;
    Viewplanetinorders1: TMenuItem;
    Produceonplanet1: TMenuItem;
    InsertDevelopTag1: TMenuItem;
    MenuItem1: TMenuItem;
    RenamePlanet1: TMenuItem;
    ClaimOwnerShip1: TMenuItem;
    ClaimOwnerShip: TMenuItem;
    FindGroupinOrders1: TMenuItem;
    N5: TMenuItem;
    Viewplanetscentered1: TMenuItem;
    lvGroups: TdfsExtListView;
    mniRandomName: TMenuItem;
    mkListView1: TmkListView;
    Unload1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AddToDefender1Click(Sender: TObject);
    procedure AddToAttacker1Click(Sender: TObject);
    procedure lbxInfoClick(Sender: TObject);
    procedure cbxGroupFilterOnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Splitter2Moved(Sender: TObject);
    procedure SendGroupsto1Click(Sender: TObject);
    procedure SendGrouptoplanets1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnSetExtraInfoClick(Sender: TObject);
    procedure mniUpgradeClick(Sender: TObject);
    procedure cbxGroupFilterInversedClick(Sender: TObject);
    procedure btnGroupFilterClick(Sender: TObject);
    procedure mniExportAllPlanetsClick(Sender: TObject);
    procedure mniExportSelectedplanetsClick(Sender: TObject);
    procedure mniAddToClipboardAsDevPlanetsClick(Sender: TObject);
    procedure mniAddToClipboardAsPlanetstoProduceClick(Sender: TObject);
    procedure btnExpressionFilterClick(Sender: TObject);
    procedure mniTopMostClick(Sender: TObject);
    procedure mniFindPlanetInOrdersClick(Sender: TObject);
    procedure FindPlanetinOrders1Click(Sender: TObject);
    procedure lbxShipsClick(Sender: TObject);
    procedure ClaimOwnerShip1Click(Sender: TObject);
    procedure InsertDevelopTag1Click(Sender: TObject);
    procedure MapMenuPopup(Sender: TObject);
    procedure Produceonplanet1Click(Sender: TObject);
    procedure RenamePlanet1Click(Sender: TObject);
    procedure Viewplanetinorders1Click(Sender: TObject);
    procedure ClaimOwnerShipClick(Sender: TObject);
    procedure planetsPopupPopup(Sender: TObject);
    procedure FindGroupinOrders1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbxShipsDblClick(Sender: TObject);
    procedure ShipsPopupPopup(Sender: TObject);
    procedure Viewplanetscentered1Click(Sender: TObject);
    procedure lvGroupsColumnClick(Sender: TObject; Column: TListColumn);
    procedure mniRandomNameClick(Sender: TObject);
    procedure mkListView1Data(Sender: TObject; Item: TListItem);
    procedure mkListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure mkListView1DblClick(Sender: TObject);
    procedure mkListView1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Unload1Click(Sender: TObject);
  private
    FIsInitialized: boolean;
    FCurrentPlanet: TPlanet;
    FLastIndex: Integer;
    FGroupAscending: boolean;
    FGroupColumn: integer;
    FExportMkListView: TExportMkListView;
    FOldIdleEvent: TIdleEvent;
    procedure DoShips(planet: TPlanet);
    procedure SetCurrentPlanet(const Value: TPlanet);
    function GetFilterGroups: boolean;
    function GetFilterGroupsInversed: boolean;
    procedure SetFilterGroups(const Value: boolean);
    procedure SetFilterGroupsInversed(const Value: boolean);
    procedure DoOnIdle(Sender: TObject; var Done: boolean);
    { Private declarations }
  public
    property FilterGroups: boolean read GetFilterGroups write SetFilterGroups;
    property FilterGroupsInversed: boolean read GetFilterGroupsInversed write SetFilterGroupsInversed;
    property CurrentPlanet: TPlanet read FCurrentPlanet write SetCurrentPlanet;
    procedure CreateRandomName(aCurrentPlanet: TPlanet);
    procedure DoClick(index: integer);
    procedure ShowPlanet(planet: TPlanet; const centered: boolean);
    procedure ShowPlanet2(planet: TPlanet; const centered: boolean);
    procedure DoRefresh;
    procedure DoGroupsSort(SortColumn: Integer; Ascending: boolean);
    { Public declarations }
  end;

var
  frmPlanets: TfrmPlanets;

procedure SetHorzExtend(listbox: TRzTabbedListBox);
procedure AddItemsToClipBoardToproduce(Items: TListItems; const planetIndex: integer);
procedure AddPlanetToClipBoardToproduce(const planetName: string);
procedure AddItemsToClipBoardAsDevPlanets(Items: TListItems; const planetIndex: integer);
procedure ClaimPlanets(Items: TListItems; const planetIndex: integer);
function GetProduceItem(var strProduce: string): boolean;

procedure DoDataFillLvPlanets(listview: TmkListView;
                              FilterGroups, InverseGroups: boolean);
function DoSmallPlanetDataComp(Item1, Item2: Pointer;
                               SortDirection: TmkSortDirection;
                               aColumn: integer): Integer;
procedure DoSmallPlanetDataDoubleClick(listview: TmkListView;
                                       index: integer);
function DoSmallPlanetDataShowPlanet(listview: Tmklistview; planet: TPlanet;
                                     SelectOne: boolean): integer;

procedure OrdersDataDevPlanets(SelectedItems: TList; const aRecordType: integer);
procedure OrdersDataClaimPlanets(SelectedItems: TList; const aRecordType: integer);
procedure OrdersDataProduceOnPlanets(SelectedItems: TList; const aRecordType: integer);

implementation

uses
  UFiles, UfrmBattleSimulator, UfrmBattles, clipbrd,
  UfrmPlanetSelect, UfrmShipDesign, UfrmSetExtraInfo, UfrmOrders,
  UfrmGroupFilter, UfrmMain, UfrmNewMap, UEliteStarNames,
  UfrmExpressionFilters, UDevelop, mkstrUtils;

{$R *.DFM}

function GetAvgCharWidth(Font: TFont): Integer;
var
  DC: HDC;
  SaveFont: HFont;
  Metrics: TTextMetric;
  S: TSize;
begin
  DC := GetDC(0);
  try
    SaveFont := SelectObject(DC, Font.Handle);

    GetTextMetrics(DC, Metrics);
    GetTextExtentPoint32(DC, 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz', 52, S);
    Result := Round(S.cx / 52);
    SelectObject(DC, SaveFont);
  finally
    ReleaseDC(0, DC);
  end;
end;

procedure SetHorzExtend(listbox: TRzTabbedListBox);
const
  MaxTabs = 1000; { A 1000 Tab Stops Should be Plenty! }
type
  PTabArray = ^TTabArray;
  TTabArray = array[0..MaxTabs - 1] of Integer;

var
  TabCount, I: Integer;
  TabArray: TTabArray;
  maxSize, Size, FDialogUnits: integer;
  tmpStr: string;
begin
  TabCount := listbox.TabStops.Count;
  if TabCount > MaxTabs then
    TabCount := MaxTabs;
  FDialogUnits := GetAvgCharWidth(listbox.Font);
  for I := 0 to TabCount - 1 do { Copy Contents of FTabStops to Temp Array }
    TabArray[I] := listbox.TabStops.Items[I] * FDialogUnits;

  // Search greatest items
  MaxSize := 0;
  for i := 0 to listbox.Items.Count - 1 do
  begin
    tmpStr := listbox.items[i] + 'xxx';

    Size := LoWord(GetTabbedTextExtent(listbox.Canvas.Handle, PChar(tmpStr), Length(tmpStr),
      TabCount, TabArray));
    if Size > maxSize then maxSize := Size;
  end;
  listbox.HorzExtent := maxSize;
end;

procedure TfrmPlanets.ShowPlanet(planet: TPlanet; const centered: boolean);
begin
  if Application.Terminated then
    Exit;
  DoSmallPlanetDataShowPlanet(mkListView1, planet, true);
  if Assigned(frmNewMap) then
    frmNewMap.Pointplanet(planet, centered);
end;

procedure TfrmPlanets.ShowPlanet2(planet: TPlanet; const centered: boolean);
var
  index: integer;
begin
  if Application.Terminated then
    Exit;
  index := DoSmallPlanetDataShowPlanet(mkListView1, planet, true);
  FLastIndex := -1;
  if index <> -1 then
    DoClick(index);
  if Assigned(frmNewMap) then
    frmNewMap.Pointplanet2(planet, centered);
end;

procedure LvPlanetsAdd(listview: TdfsExtListView; curplanet: TPlanet);
var
  newListItem: TListItem;
  owner: string;
begin
  curPlanet.SetLastOwner;
  case curPlanet.LastOwnerType of
    1: owner := curPlanet.LastOwnerName;
    2: if curPlanet.LastOwnerTurn > -1 then
        owner := format('?(%d) %s', [curPlanet.LastOwnerTurn, curPlanet.LastOwnerName])
      else
        owner := '?';
    3: owner := format('??(%d) %s', [curPlanet.LastOwnerTurn, curPlanet.LastOwnerName]);
  end;
  newListItem := listview.Items.Add;
  newListItem.Data := curPlanet; // for later gebruik
  newListItem.Caption := curPlanet.Name;
  newListItem.SubItems.Add(Format('%4.2f', [curPlanet.Distance / 100])); //Add('0');
  newListItem.SubItems.Add(owner);
end;

procedure DoFillLvPlanets(listview: TdfsExtListView; FilterGroups, InverseGroups: boolean);
var
  i: integer;
  curPlanet: TPlanet;
  list: TList;
begin
  if not Assigned(frmGroupFilter) then Exit;
  listview.BeginUpdate;
  list := TList.Create;
  listview.Items.Clear;
  try
    if FilterGroups then
    begin
      frmGroupFilter.GroupFilter.CalculateGroupsOnPlanet;
      for i := 0 to planets.count - 1 do
      begin
        curPlanet := TPlanet(Planets.Objects[i]);
        if frmExpressionFilters.Filteredplanets.IndexOf(curPlanet) = -1 then continue;
        if (not FilterGroups or (FilterGroups and ((frmGroupFilter.GroupFilter.GroupsOnPlanets.IndexOf(curPlanet) <> -1) xor InverseGroups))) then
          LvPlanetsAdd(listview, curplanet);
      end;
    end
    else
      for i := 0 to planets.count - 1 do
      begin
        curPlanet := TPlanet(Planets.Objects[i]);
        if frmExpressionFilters.Filteredplanets.IndexOf(curPlanet) = -1 then continue;
        LvPlanetsAdd(listview, curplanet);
      end;
  finally
    list.Free;
    listview.EndUpdate;
  end;
end;

procedure TfrmPlanets.DoClick(index: integer);
var
  planet: TPlanet;
  strTemp: string;
  pr, t, i: integer;
  d, w, w1, p, p1, r, r1, m, m1: single;
  lastBattle: TBattle;
  IncomingGroup: TIncomingGroup;
  devPlanet: TdevPlanet;
  dx, dy: Single;
begin
  if FLastIndex = index then Exit
  else FLastIndex := index;
  if not (index < mkListView1.Items.Count) or (index < 0) then Exit;
  planet := PSmallPlanetData(mkListView1.ViewList[index]).planet;
  btnSetExtraInfo.Enabled := Assigned(planet.playerCur);
  CurrentPlanet := planet;
  lbxInfo.Clear;
  lbxInfo.Items.AddObject('Name:'#9 + planet.Name, nil);
  lbxInfo.Items.AddObject('Nr:'#9 + Format('%03d', [planet.Nr]), nil);
  lbxInfo.Items.AddObject('Owner:'#9 + PSmallPlanetData(mkListView1.ViewList[index]).owner, nil);
  lbxInfo.Items.AddObject('Size:'#9 + Format('%04.2f', [planet.size]), nil);
  lbxInfo.Items.AddObject('Res.:'#9 + Format('%04.2f'#9'x: %04.2f y: %04.2f', [planet.Resources, planet.x / 100, planet.y / 100]), nil);

  if (planet.size > 0) then
    pr := round(((100.0 * planet.PopulationCur / planet.size) + 0.5))
  else
    pr := 0;
  strTemp := Format('%04.2f'#9'%03d%%', [planet.PopulationCur, pr]);
  if ((pr < 100) and (planet.PopulationCur > 0)) then begin
    w := planet.PopulationCur;
    t := 0;
    while w < planet.size do begin
      w := w * 1.08;
      inc(t);
    end;
    strTemp := strTemp + Format(#9'%d#', [t]);
  end;
  lbxInfo.Items.AddObject('Popul.:'#9 + strTemp, nil);

  if (planet.size > 0) then
    pr := round(((100.0 * planet.IndustryCur / planet.size) + 0.5))
  else
    pr := 0;
  strTemp := Format('%04.2f'#9'%3d%%', [planet.IndustryCur, pr]);
  if ((pr < 100) and (planet.IndustryCur > 0) and (planet.Resources > 0)) then
  begin
    w := planet.IndustryCur;
    w1 := planet.PopulationCur;
    t := 0;
    while w < planet.size do begin
      p := w;
      if (w1 > w) then p := p + (w1 - w) / 4;
      r := 1 / planet.Resources;
      if inivars.Gametype = gtGalaxyBlind then
        w := w + (p / (5 + r) * 2)     // Blind uses other rule
      else
        w := w + p / (5 + r);

      w1 := w1 * 1.08;
      if w1 > planet.size then w1 := planet.size;
      inc(t);
    end;
    strTemp := strTemp + Format(#9'%d#', [t]);
  end;

  lbxInfo.Items.AddObject('Industry:'#9 + strTemp, nil);
  devPlanet := FindDevPlanet(planet);
  if Assigned(devPlanet) then
    lbxInfo.Items.AddObject('Prod.:'#9 + Format('%04.2f (%04.2f)', [devplanet.devAvailableIndustry[0], planet.EffIndustryCur]), nil)
  else
    lbxInfo.Items.AddObject('Prod.:'#9 + Format('%04.2f', [planet.EffIndustryCur]), nil);
  lbxInfo.Items.AddObject('CAP:'#9 + Format('%04.2f', [planet.CapitalCur]), nil);
  lbxInfo.Items.AddObject('MAT:'#9 + Format('%04.2f', [planet.MaterialCur]), nil);
  lbxInfo.Items.AddObject('COL:'#9 + Format('%04.2f', [planet.ColonistCur]), nil);

  p1 := planet.size;
  r1 := planet.Resources;
  m1 := (p1 * r1) / (10.0 * r1 + 1.0);
  m := planet.EffMassProduceCur;
  lbxInfo.Items.AddObject('Max ship:'#9 + Format('%4.2f (%4.2f)', [m, m1]), nil);
  lbxInfo.Items.Add(Format('My Mass:'#9#9'%5.2f', [planet.MyShipMass]));
  lbxInfo.Items.Add(Format('Friendly Mass:'#9'%5.2f', [planet.FriendShipMass]));
  lbxInfo.Items.Add(Format('Enemy Mass:'#9'%5.2f', [planet.EnemyShipMass]));
  lbxInfo.Items.Add(Format('Sent Mass:'#9#9'%5.2f / %5.2f / %5.2f', [planet.SendedShipMass, planet.SendedShipMassETA2, planet.SendedShipMassETA2Plus]));
  m := 0;
  for i := 0 to IncomingGroups.Count - 1 do begin
    IncomingGroup := TIncomingGroup(IncomingGroups[i]);
    if (IncomingGroup.Turn = LastTurn) and (IncomingGroup.DestPlanet = planet) then
      m := m + IncomingGroup.mass;
  end;
  if m > 0 then
    lbxInfo.Items.Add(Format('Incoming Mass:'#9'%5.2f', [m]));
  lbxInfo.Items.Add(Format('Producing:'#9'%s'#9'%5.3f (%5.3f)', [planet.ProduceType, planet.ProduceAmount, planet.ProduceAmountFull]));
  lastBattle := nil;
  for i := 0 to battles.Count - 1 do
    if TBattle(battles.Objects[i]).Planet = planet then
      lastBattle := TBattle(battles.Objects[i]);
  if lastBattle <> nil then
    lbxInfo.Items.AddObject(Format('Last fight:'#9'%d', [lastBattle.turn]), lastBattle);
  if Assigned(planet1) and Assigned(planet2) then begin
    dx := planet1.x - planet2.x;
    dy := planet1.y - planet2.y;
    d := sqrt(dx * dx + dy * dy);
    lbxInfo.Items.Add(Format('Dist. '#39'%s'#39' - '#39'%s'#39': %4.2f', [planet1.Name, planet2.Name, d / 100]));
  end;
  SetHorzExtend(lbxInfo);
  DoShips(planet);
end;

procedure TfrmPlanets.DoShips(planet: TPlanet);
var
  i, j: integer;
  bPrintPlayer: boolean;
  group: TGroup;
  player: TPlayer;
  SendedGroup: TSendedGroup;
  IncomingGroup: TIncomingGroup;
  m: integer;
  listItem: TListItem;
begin
  lvGroups.BeginUpdate;
  try
    lvGroups.Items.Clear;
    bPrintPlayer := True;
    for j := 0 to SendedGroups.Count - 1 do begin
      SendedGroup := TSendedGroup(SendedGroups.Objects[j]);
      if ((SendedGroup.sendFrom = planet) and SendedGroup.IsOrgGroup) or
         (SendedGroup.sendTo = planet) then begin
        if not Assigned(SendedGroup.orgGroup) or
           ((SendedGroup.orgGroup.LocPlanet = planet)
            and not(SendedGroup.sendFrom = SendedGroup.sendTo)) then continue;
        if bPrintPlayer then begin
          listItem := lvGroups.Items.Add;
          listItem.SubItems.Add('');
          listItem.SubItems.Add('');
          listItem.SubItems.Add('');
          listItem.SubItems.Add(qReportPlayer.name + ' groups:');
          listItem.Data := nil;
          bPrintPlayer := False;
        end;
        listItem := lvGroups.Items.Add;
        if (SendedGroup.sendTo = planet) and (SendedGroup.orgGroup.LocPlanet = nil) then
          listItem.Caption := Format('(%d)', [SendedGroup.orgGroup.Nr])
        else
          listItem.Caption := Format('%d', [SendedGroup.orgGroup.Nr]);
        if (SendedGroup.GetSpeed = 0) or (SendedGroup.sendToGo = 0) or
          ((SendedGroup.sendToGo > 0) and (SendedGroup.sendFrom = planet)
           and (SendedGroup.sendFrom <> SendedGroup.sendTo)) then
          listItem.SubItems.Add('-')
        else
          listItem.SubItems.Add(Format('#%d', [Round(SendedGroup.sendToGo / SendedGroup.GetSpeed + 0.5)]));
        if assigned(SendedGroup.sendFrom) and (SendedGroup.sendFrom <> planet) then
          listItem.SubItems.Add(SendedGroup.sendFrom.Name)
        else
          listItem.SubItems.Add('');

        if (SendedGroup.sendToGo > 0) and (SendedGroup.sendTo = planet) and
           (SendedGroup.orgGroup.LocPlanet = nil)then begin
          listItem.SubItems.Add(Format('%d', [SendedGroup.sendAantal]));
          listItem.SubItems.Add(SendedGroup.orgGroup._Type.Name);
          listItem.SubItems.Add(Format('(%3.2f)', [SendedGroup.orgGroup.EffSpeed]));
          listItem.SubItems.Add(Format('%3.2f', [SendedGroup.GetSpeed]));

        end else begin
          if (SendedGroup.sendTo = planet) and (SendedGroup.orgGroup.LocPlanet = nil) then
            listItem.SubItems.Add(Format('%d', [SendedGroup.sendAantal]))
          else
            listItem.SubItems.Add(Format('%d (%d)', [SendedGroup.orgGroup.aantal, GetMaxToSend(SendedGroup.orgGroup)]));
          if SendedGroup.orgGroup.FleetName = '' then
            listItem.SubItems.Add(SendedGroup.orgGroup._Type.Name)
          else
            listItem.SubItems.Add(Format('%s (%s)', [SendedGroup.orgGroup._Type.Name, SendedGroup.orgGroup.FleetName]));
          listItem.SubItems.Add(Format('%3.2f', [SendedGroup.orgGroup.EffSpeed]));
          listItem.SubItems.Add(Format('%3.2f', [SendedGroup.orgGroup.EffSpeedloaded]));
        end;

        if SendedGroup.orgGroup._Type.Attacks > 0 then begin
          listItem.SubItems.Add(Format('%d', [SendedGroup.orgGroup._Type.Attacks]));
          listItem.SubItems.Add(Format('%3.1f', [SendedGroup.orgGroup.Effweapon]));
        end else begin
          listItem.SubItems.Add('-');
          listItem.SubItems.Add('-');
        end;
        if SendedGroup.orgGroup.EffShield > 0 then
          listItem.SubItems.Add(Format('%3.1f', [SendedGroup.orgGroup.EffShield]))
        else
          listItem.SubItems.Add('-');
        listItem.SubItems.Add(Format('%3.1f', [SendedGroup.orgGroup._Type.Mass]));

        listItem.SubItems.Add('-');
        listItem.SubItems.Add('-');
        listItem.SubItems.Add('-');
        if SendedGroup.orgGroup.EffCargo > 0 then
        begin
          listItem.SubItems[10] := Format('%3.1f', [SendedGroup.orgGroup.EffCargo]);

          if SendedGroup.sendQuantity > 0 then
          begin
            listItem.SubItems[11] := Format('%3.1f', [SendedGroup.sendQuantity * SendedGroup.sendAantal]);
            case SendedGroup.sendCargoType of
              P_CAP: listItem.SubItems[12] := 'CAP';
              P_COL: listItem.SubItems[12] := 'COL';
              P_MAT: listItem.SubItems[12] := 'MAT';
            else
              listItem.SubItems[12] := '???';
            end;
          end;
        end;
        if (SendedGroup.sendFrom = planet) or
          ((SendedGroup.sendTo = planet) and (SendedGroup.orgGroup.LocPlanet = nil)) then
        begin
          listItem.Data := SendedGroup.orgGroup;
          SendedGroup.orgGroup.SourcePlanet := SendedGroup.sendFrom;
          SendedGroup.orgGroup.DestPlanet := SendedGroup.sendTo;
          SendedGroup.orgGroup.ETA := SendedGroup.ETA;
        end else
          listItem.Data :=  nil;
      end;
    end;
    for i := 0 to players.Count - 1 do
    begin
      bPrintPlayer := True;
      player := TPlayer(players.Objects[i]);
      if player <> qReportPlayer then begin
        for j := 0 to player.Groups.Count - 1 do
        begin
          group := TGroup(player.Groups[j]);
          if group.planet = planet then
          begin
            if bPrintPlayer then
            begin
              if lvGroups.Items.Count > 0 then
                lvGroups.Items.Add;
              listItem := lvGroups.Items.Add;
              listItem.SubItems.Add('');
              listItem.SubItems.Add('');
              listItem.SubItems.Add('');
              listItem.SubItems.Add(player.name + ' groups:');
              listItem.Data := nil;
              bPrintPlayer := False;
            end;
            listItem := lvGroups.Items.Add;
            if group.Nr > 0 then
              listItem.Caption := Format('%d', [group.Nr])
            else
              listItem.Caption := '-';
            if (player <> qreportPlayer) and (group.Turn < lastturn) then
              listItem.SubItems.Add(Format('(%d)', [group.turn]))
            else
              if (group.ETA > 0) then
                listItem.SubItems.Add(Format('#%d', [group.ETA]))
              else
                listItem.SubItems.Add('-');

            if assigned(group.LocPlanet) and (group.LocPlanet <> planet)then
              listItem.SubItems.Add(group.LocPlanet.Name)
            else
              listItem.SubItems.Add('');
            listItem.SubItems.Add(Format('%d', [group.aantal]));

            if group.FleetName = '' then
              listItem.SubItems.Add(group._Type.Name)
            else
              listItem.SubItems.Add(Format('%s (%s)', [group._Type.Name, group.FleetName]));
            listItem.SubItems.Add(Format('%3.2f', [group.EffSpeed]));
            listItem.SubItems.Add(Format('%3.2f', [group.EffSpeedloaded]));
            if group._Type.Attacks > 0 then begin
              listItem.SubItems.Add(Format('%d', [group._Type.Attacks]));
              listItem.SubItems.Add(Format('%3.1f', [group.Effweapon]));
            end else begin
              listItem.SubItems.Add('-');
              listItem.SubItems.Add('-');
            end;
            if group.EffShield > 0 then
              listItem.SubItems.Add(Format('%3.1f', [group.EffShield]))
            else
              listItem.SubItems.Add('-');
            listItem.SubItems.Add(Format('%3.1f', [group._Type.Mass]));

            listItem.SubItems.Add('-');
            listItem.SubItems.Add('-');
            listItem.SubItems.Add('-');
            if group.EffCargo > 0 then
            begin
              listItem.SubItems[10] := Format('%3.1f', [group.EffCargo]);
              if group.Lading > 0 then
              begin
                listItem.SubItems[11] := Format('%3.1f', [group.Lading * group.aantal]);
                case group.LadingType of
                  P_CAP: listItem.SubItems[12] := 'CAP';
                  P_COL: listItem.SubItems[12] := 'COL';
                  P_MAT: listItem.SubItems[12] := 'MAT';
                else
                  listItem.SubItems[12] := '???';
                end;
              end;
            end
            else;
            listItem.Data := group;
          end;
        end;
      end;
    end;
    m := 0;
    for i := 0 to IncomingGroups.Count - 1 do begin
      IncomingGroup := TIncomingGroup(IncomingGroups[i]);
      if (IncomingGroup.Turn = LastTurn) and (IncomingGroup.DestPlanet = planet) and
        Assigned(IncomingGroup.FromPlanet) then
        inc(m);
    end;
    if m > 0 then begin
      if lvGroups.Items.Count > 0 then
        lvGroups.Items.Add;
      listitem := lvGroups.Items.Add;
      listitem.SubItems.Add('');
      listitem.SubItems.Add('');
      listitem.SubItems.Add('');
      if m = 1 then
        listitem.SubItems.Add('Incoming Group')
      else
        listitem.SubItems.Add('Incoming Groups');
      listitem := lvGroups.Items.Add;
      listitem.SubItems.Add('');
      listitem.SubItems.Add('');
      listitem.SubItems.Add('');
      listitem.SubItems.Add('From');
      listitem.SubItems.Add('Range');
      listitem.SubItems.Add('Speed');
      listitem.SubItems.Add('Mass');
      for i := 0 to IncomingGroups.Count - 1 do begin
        IncomingGroup := TIncomingGroup(IncomingGroups[i]);
        if (IncomingGroup.Turn = LastTurn) and (IncomingGroup.DestPlanet = planet) then begin
          listitem := lvGroups.Items.Add;
          listitem.SubItems.Add('');
          listitem.SubItems.Add('');
          listitem.SubItems.Add('');
          listitem.SubItems.Add(Format('%s', [IncomingGroup.FromPlanet.Name]));
          listitem.SubItems.Add(Format('%4.1f', [IncomingGroup.Range]));
          listitem.SubItems.Add(Format('%4.1f', [IncomingGroup.Speed]));
          listitem.SubItems.Add(Format('%4.1f', [IncomingGroup.Mass]));
        end;
      end;
    end;
  finally
    lvGroups.EndUpdate;
  end;
end;

procedure TfrmPlanets.FormShow(Sender: TObject);
begin
  mniRandomName.Visible := inivars.EliteNameCreation;
  DoDataFillLvPlanets(mkListView1, FilterGroups, False);
  lbxInfo.Items.Clear;
  lvGroups.BeginUpdate;
  try
    lvGroups.Items.Clear;
  finally
    lvGroups.EndUpdate;
  end;
  FLastIndex := -1;
end;

procedure TfrmPlanets.FormCreate(Sender: TObject);
begin
  FGroupAscending := true;
  FGroupColumn := -2;

  mkListView1.ViewList.CompareFunc := DoSmallPlanetDataComp;

  FIsInitialized := False;
  OvcComponentState1.Section := 'TfrmPlanets_' + GetGameStr;
  FExportMkListView := TExportMkListView.Create(Self);
  FExportMkListView.ExportType := xHTML;
  FExportMkListView.Options := [ExportAllWhenNoneSelected,
                                SelectedRowsOnly,
                                ShowClipboardMsg,
                                ShowProgress,
                                TimeStamp];
  FExportMkListView.Header := 'Planets';
  FExportMkListView.Footer := frmMKGal.Caption;
  FExportMkListView.Title := 'MKGal';
  FExportMkListView.ViewOnly := true;
  FExportMkListView.ListView := mkListView1;
end;

procedure TfrmPlanets.AddToDefender1Click(Sender: TObject);
var
  group: TGroup;
  i: integer;
begin
  for i := 0 to lvGroups.Items.Count - 1 do begin
    if lvGroups.items[i].selected then begin
      if lvGroups.items[i].Data <> nil then begin
        group := NewGroup(TGroup(lvGroups.items[i].Data));
        frmBattleSimulator.AddGroupToDefenders(group);
      end;
    end;
  end;
  frmBattleSimulator.UpdateBattleSim;
end;

procedure TfrmPlanets.AddToAttacker1Click(Sender: TObject);
var
  group: TGroup;
  i: integer;
begin
  for i := 0 to lvGroups.Items.Count - 1 do begin
    if lvGroups.Items[i].selected then begin
      if lvGroups.Items[i].Data <> nil then begin
        group := NewGroup(TGroup(lvGroups.Items[i].data));
        frmBattleSimulator.AddGroupToAttackers(group);
      end;
    end;
  end;
  frmBattleSimulator.UpdateBattleSim;
end;

procedure TfrmPlanets.lbxInfoClick(Sender: TObject);
begin
  if lbxInfo.ItemIndex <> -1 then
    if TObject(lbxInfo.Items.Objects[lbxInfo.ItemIndex]) is TBattle then
      frmBattles.GoToBattle(TBattle(lbxInfo.Items.Objects[lbxInfo.ItemIndex]));
end;

procedure TfrmPlanets.cbxGroupFilterOnClick(Sender: TObject);
begin
  FIsInitialized := False;
  DoDataFillLvPlanets(mkListView1, FilterGroups, FilterGroupsInversed);
  lbxInfo.Items.Clear;
  lvGroups.Items.Clear;
end;

procedure TfrmPlanets.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsMinimized;
  CanClose := false;
end;

procedure TfrmPlanets.Splitter2Moved(Sender: TObject);
begin
  SetHorzExtend(lbxInfo);
end;

procedure TfrmPlanets.SendGroupsto1Click(Sender: TObject);
var
  group: TGroup;
  i: integer;
begin
  if frmPlanetSelect.working then
    Exit;
  frmPlanetSelect.working := True;
  frmPlanetSelect.SelectedGroups.Clear;
  for i := 0 to lvGroups.Items.Count - 1 do
    if lvGroups.Items[i].selected then
      if lvGroups.Items[i].Data <> nil then begin
        group := TGroup(lvGroups.Items[i].data);
        if (group.Player = qreportPlayer) and (group.EffSpeed > 0) and
          (group.ETA = 0) and (GetMaxToSend(Group) > 0) then
          frmPlanetSelect.SelectedGroups.AddObject(IntToStr(group.Nr), group);
      end;
  if frmPlanetSelect.SelectedGroups.Count > 0 then begin
    frmPlanetSelect.SelectedPlanets.Clear;
    frmPlanetSelect.SelectMulti := False;
    frmPlanetSelect.Execute;
  end
  else
    frmPlanetSelect.working := False;
end;

procedure TfrmPlanets.SendGrouptoplanets1Click(Sender: TObject);
var
  group: TGroup;
  i: integer;
begin
  if frmPlanetSelect.working then
    Exit;
  frmPlanetSelect.working := True;
  frmPlanetSelect.SelectedGroups.Clear;
  i := 0;
  group := nil;
  while (i < lvGroups.Items.Count) and (group = nil) do begin
    if lvGroups.Items[i].selected then
      if lvGroups.Items[i].data <> nil then begin
        group := TGroup(lvGroups.Items[i].data);
        if (group.Player = qreportPlayer) and (group.EffSpeed > 0) and
          (group.ETA = 0) and (GetMaxToSend(Group) > 0) then
        begin
          frmPlanetSelect.MaxShips := group.Aantal;
          frmPlanetSelect.SelectedGroups.AddObject(IntToStr(group.Nr), group);
        end
        else
          group := nil;
      end;
    inc(i);
  end;
  if frmPlanetSelect.SelectedGroups.Count > 0 then begin
    frmPlanetSelect.SelectedPlanets.Clear;
    frmPlanetSelect.SelectMulti := True;
    frmPlanetSelect.Execute;
  end
  else
    frmPlanetSelect.working := False;
end;

procedure TfrmPlanets.Button1Click(Sender: TObject);
begin
  ExtraPlanetInfoList.WriteInfo(ExtractFilePath(ParamStr(0)) + 'ExtrInf.ini');
  ShowMessage('Saved');
end;

procedure TfrmPlanets.btnSetExtraInfoClick(Sender: TObject);
var
  listItem: TListItem;
  i: integer;
begin
  frmSetExtraInfo.PlanetName := FCurrentPlanet.Name;
  frmSetExtraInfo.Planet := FCurrentPlanet;
  frmSetExtraInfo.Player := FCurrentPlanet.PlayerCur;
  frmSetExtraInfo.ShowModal;
  if (frmSetExtraInfo.ModalResult = mrOK) or (frmSetExtraInfo.ModalResult = mrNO) then
  begin
    if frmSetExtraInfo.Player <> FCurrentPlanet.PlayerCur then
    begin
      FCurrentPlanet.PlayerCur := frmSetExtraInfo.Player;
      if (frmSetExtraInfo.ModalResult = mrOK) then
        ExtraPlanetInfoList.AddPlanet(FCurrentPlanet, frmSetExtraInfo.Player)
      else
        ExtraPlanetInfoList.DeletePlanet(FCurrentPlanet);
      FCurrentPlanet.PlayerCur := frmSetExtraInfo.Player;

      FIsInitialized := False;
      DoDataFillLvPlanets(mkListView1, FilterGroups, FilterGroupsInversed);
      lbxInfo.Items.Clear;
      lvGroups.Items.Clear;
      i := 0;
      while i < mkListView1.ViewList.Count do begin
        if FCurrentPlanet = PSmallPlanetData(mkListView1.ViewList[i]).planet then begin
          listItem := mkListView1.Items[i];
          if listItem = nil then Exit;
          listItem.MakeVisible(False);
          listItem.Selected := true;
          DoClick(-1);
          DoSmallPlanetDataDoubleClick(mkListView1, listitem.index);
          DoClick(listitem.index);
          break;
        end;
        inc(i);
      end;
      FIsInitialized := True;
    end;
  end;
end;

procedure TfrmPlanets.SetCurrentPlanet(const Value: TPlanet);
begin
  FCurrentPlanet := Value;
end;

procedure TfrmPlanets.mniUpgradeClick(Sender: TObject);
var
  group: TGroup;
  i: integer;
  list: TStrings;
  orders: string;
begin
  list := TStringlist.Create;
  try
    for i := 0 to lvGroups.Items.Count - 1 do
      if lvGroups.Items[i].selected then
        if lvGroups.Items[i].data <> nil then
        begin
          group := TGroup(lvGroups.Items[i].data);
          if group.Player = qreportPlayer then
            list.Add(IntToStr(group.Nr));
        end;
    if list.Count > 0 then
    begin
      for i := 0 to list.Count - 2 do
        orders := orders + 'G ' + list.Strings[i] + #13#10;
      orders := orders + 'G ' + list.Strings[list.Count - 1];
      frmOrders.InsertCommand(orders);
      frmOrders.AnalyseAndDoOutput;
    end;
  finally
    list.free;
  end;
end;

procedure TfrmPlanets.cbxGroupFilterInversedClick(Sender: TObject);
begin
  FIsInitialized := False;
  if FilterGroups then
    DoDataFillLvPlanets(mkListView1, FilterGroups, FilterGroupsInversed);
  lbxInfo.Items.Clear;
  lvGroups.Items.Clear;
end;

procedure TfrmPlanets.btnGroupFilterClick(Sender: TObject);
begin
  frmGroupFilter.ShowModal;
  FIsInitialized := False;
  Screen.Cursor := crHourGlass;
  try
    if FilterGroups then
      DoDataFillLvPlanets(mkListView1, FilterGroups, FilterGroupsInversed);
    lbxInfo.Items.Clear;
    lvGroups.Items.Clear;
  finally
    Screen.Cursor := crDefault;
  end;
end;

function TfrmPlanets.GetFilterGroups: boolean;
begin
  Result := cbxGroupFilterOn.Checked;
end;

function TfrmPlanets.GetFilterGroupsInversed: boolean;
begin
  Result := cbxGroupFilterInversed.Checked;
end;

procedure TfrmPlanets.SetFilterGroups(const Value: boolean);
begin
  cbxGroupFilterOn.Checked := Value;
end;

procedure TfrmPlanets.SetFilterGroupsInversed(const Value: boolean);
begin
  cbxGroupFilterInversed.Checked := Value;
end;

procedure TfrmPlanets.mniExportAllPlanetsClick(Sender: TObject);
begin
  FExportMkListView.Options := FExportMkListView.Options - [SelectedRowsonly];
  FExportMkListView.Choose;
end;

procedure TfrmPlanets.mniExportSelectedplanetsClick(Sender: TObject);
begin
  FExportMkListView.Options := FExportMkListView.Options + [SelectedRowsonly];
  FExportMkListView.Choose;
end;

procedure TfrmPlanets.mniAddToClipboardAsDevPlanetsClick(Sender: TObject);
begin
  mkListView1.GetSelectedItems;
  OrdersDataDevPlanets(mkListView1.SelectedList, 1);
end;

procedure AddItemsToClipBoardAsDevPlanets(Items: TListItems; const planetIndex: integer);
var
  i: integer;
  strText: string;
  planetName: string;
begin
  strText := '';
  for i := 0 to Items.Count - 1 do begin
    if Items[i].Selected then begin
      if strText <> '' then strText := strtext + #13#10;
      if planetIndex = -1 then planetName := Items[i].Caption
      else planetName := Items[i].SubItems[planetIndex];
      strText := strText + ';P ' + planetName;
    end;
  end;
  frmOrders.InsertPlanetCommand(strText);
end;

procedure ClaimPlanets(Items: TListItems; const planetIndex: integer);
var
  i: integer;
  strText: string;
  planetName: string;
begin
  strText := '';
  for i := 0 to Items.Count - 1 do begin
    if Items[i].Selected then begin
      if strText <> '' then strText := strtext + #13#10;
      if planetIndex = -1 then planetName := Items[i].Caption
      else planetName := Items[i].SubItems[planetIndex];
      strText := strText + 'V ' + planetName;
    end;
  end;
  frmOrders.InsertPlanetCommand(strText);
end;

procedure TfrmPlanets.mniAddToClipboardAsPlanetstoProduceClick(
  Sender: TObject);
begin
  mkListView1.GetSelectedItems;
  OrdersDataProduceOnPlanets(mkListView1.SelectedList, 1);
end;

function GetProduceItem(var strProduce: string): boolean;
var
  RzLookupDialog: TRzLookupDialog;
begin
  Result := False;
  RzLookupDialog := TRzLookupDialog.Create(nil);
  try
    RzLookupDialog.Prompt := 'Select item to produce';
    RzLookupDialog.SearchString := strProduce;
    RzLookupDialog.List.CommaText := '"CAP", "MAT", "DRIVE", "WEAPONS", "SHIELDS", "CARGO"';
    AppendShipTypesToList(qReportPlayer, RzLookupDialog.List);
    if RzLookupDialog.Execute then begin
      strProduce := RzLookupDialog.SelectedItem;
      Result := True;
    end;
  finally
    RzLookupDialog.Free;
  end;
end;

procedure AddItemsToClipBoardToproduce(Items: TListItems; const planetIndex: integer);
const
  strProduce: string = '';
var
  i: integer;
  strText: string;
begin
  strText := '';
  if GetProduceItem(strProduce) then begin
    for i := 0 to Items.Count - 1 do begin
      if Items[i].Selected then begin
        if strText <> '' then strText := strtext + #13#10;
        if planetIndex = -1 then
          strText := strText + 'P ' + Items[i].Caption + ' ' + strProduce
        else
          strText := strText + 'P ' + Items[i].SubItems[planetIndex] + ' ' + strProduce;
      end;
    end;
    frmOrders.InsertPlanetCommand(strText);
  end;
end;

procedure AddPlanetToClipBoardToproduce(const planetName: string);
const
  strProduce: string = '';
begin
  if GetProduceItem(strProduce) then begin
    frmOrders.InsertPlanetCommand('P ' + planetName + ' ' + strProduce);
  end;
end;

procedure TfrmPlanets.btnExpressionFilterClick(Sender: TObject);
var
  i: integer;
begin
  frmExpressionFilters.ClearFilteredPlanets;
  if frmExpressionFilters.ShowModal <> mrOK then
    for i := 0 to planets.Count -1 do
      frmExpressionFilters.Filteredplanets.Add(planets.objects[i]);
  Screen.Cursor := crHourGlass;
  try
    DoDataFillLvPlanets(mkListView1, FilterGroups, FilterGroupsInversed);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmPlanets.mniTopMostClick(Sender: TObject);
begin
  mniTopMost.Checked := not mniTopMost.Checked;
  TopmostWindow1.AlwaysOnTop := mniTopMost.Checked;
end;

procedure TfrmPlanets.mniFindPlanetInOrdersClick(Sender: TObject);
begin
  if Assigned(mkListview1.Selected) then
    frmOrders.FindFirstPlanetInOrders(mkListview1.Selected.Caption);
end;

procedure TfrmPlanets.FindPlanetinOrders1Click(Sender: TObject);
var
  strPlanet: string;
begin
  if lbxInfo.Items.Count > 0 then begin
    strPlanet := lbxInfo.Items[0];
    while pos(#9, strPlanet) > 0 do
      delete(strPlanet, 1, pos(#9, strPlanet));
    frmOrders.FindFirstPlanetInOrders(strplanet);
  end;
end;

procedure TfrmPlanets.lbxShipsClick(Sender: TObject);
var
  group: TGroup;
begin
  if Assigned(lvGroups.Selected) then begin
    group := TGroup(lvGroups.Selected.Data);
    if Assigned(group) then begin
      frmNewMap.GroupCursor.SetGroup(group.planet.X, group.planet.Y, group.EffSpeed, group.EffSpeedLoaded);
      frmNewMap.Repaint;
    end else begin
      frmNewMap.GroupCursor.SetGroup(0, 0, 0, 0);
      frmNewMap.Repaint;
    end;
  end;
end;

procedure TfrmPlanets.ClaimOwnerShip1Click(Sender: TObject);
begin
  frmOrders.InsertPlanetCommand('V ' + CurrentPlanet.Name);
end;

procedure TfrmPlanets.InsertDevelopTag1Click(Sender: TObject);
begin
  frmOrders.InsertPlanetCommand(';P ' + CurrentPlanet.Name);
end;

procedure TfrmPlanets.MapMenuPopup(Sender: TObject);
begin
  ClaimOwnerShip1.Visible := inivars.Gametype <> gtGalaxyBlind;
  Viewplanetinorders1.Enabled := Assigned(CurrentPlanet);
  RenamePlanet1.Enabled := Assigned(CurrentPlanet) and (CurrentPlanet.PlayerCur = qReportPlayer);
  InsertDevelopTag1.Enabled := Assigned(CurrentPlanet);
  ClaimOwnerShip1.Enabled := Assigned(CurrentPlanet);
  Produceonplanet1.Enabled := Assigned(CurrentPlanet) and (CurrentPlanet.PlayerCur = qReportPlayer);
end;

procedure TfrmPlanets.Produceonplanet1Click(Sender: TObject);
begin
  AddPlanetToClipBoardToproduce(CurrentPlanet.Name)
end;

procedure TfrmPlanets.RenamePlanet1Click(Sender: TObject);
var
  strNewPlanetName: string;
  index: integer;
begin
  if Assigned(CurrentPlanet) then begin
    strNewPlanetName := CurrentPlanet.Name;
    if Inputquery('Create Order', 'Enter new planet name', strNewPlanetName) then begin
      for index := 0 to planets.Count - 1 do
        if (CompareText(strNewPlanetName, Planets[index]) = 0) and
          (Planets.objects[index] <> CurrentPlanet) then begin
          ShowMessage('Planet Name already used!');
          Exit;
        end;
      frmOrders.InsertPlanetCommand('N ' + CurrentPlanet.Name + ' ' + strNewPlanetName);
    end;
  end;
end;

procedure TfrmPlanets.Viewplanetinorders1Click(Sender: TObject);
begin
  if Assigned(CurrentPlanet) then
    frmOrders.FindFirstPlanetInOrders(CurrentPlanet.Name);
end;

procedure TfrmPlanets.ClaimOwnerShipClick(Sender: TObject);
begin
  mkListView1.GetSelectedItems;
  OrdersDataClaimPlanets(mkListview1.SelectedList, 1);
end;

procedure TfrmPlanets.planetsPopupPopup(Sender: TObject);
begin
  ClaimOwnerShip.Visible := inivars.Gametype = gtGalaxyNG;
end;

procedure TfrmPlanets.DoRefresh;
var
  index: integer;
begin
  index := FLastIndex;
  FLastIndex := -1;
  DoClick(index);
end;

procedure TfrmPlanets.FindGroupinOrders1Click(Sender: TObject);
var
  group: TGroup;
  i: integer;
begin
  i := 0;
  group := nil;
  while (i < lvGroups.Items.Count) and (group = nil) do begin
    if lvGroups.items[i].selected then
      group := Tgroup(lvGroups.Items[i].data);
    inc(i);
  end;
  if assigned(group) then
    frmOrders.FindFirstGroupInOrders(mkItoA(group.nr));
end;

procedure TfrmPlanets.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F5) then
    DoRefresh;
  if (Key = VK_F6) then
    frmOrders.DoAnalyseButton;
end;

procedure TfrmPlanets.lbxShipsDblClick(Sender: TObject);
var
  group: TGroup;
begin
  if Assigned(lvGroups.Selected) then begin
    group := TGroup(lvGroups.Selected.Data);
    if Assigned(group) then begin
      if (CurrentPlanet = group.SourcePlanet) and Assigned(group.DestPlanet) then begin
        ShowPlanet(group.DestPlanet, Viewplanetscentered1.Checked);
      end else begin
        ShowPlanet(group.SourcePlanet, Viewplanetscentered1.Checked);
      end;
    end else begin
      frmNewMap.GroupCursor.SetGroup(0, 0, 0, 0);
      frmNewMap.Repaint;
    end;
  end;
end;

procedure TfrmPlanets.ShipsPopupPopup(Sender: TObject);
var
  bOneSelected: boolean;
  bMoreSelected: boolean;
begin
  bOneSelected := lvGroups.SelCount = 1;
  bMoreSelected := lvGroups.SelCount > 0;
  AddToDefender1.Enabled := bMoreSelected;
  AddToAttacker1.Enabled := bMoreSelected;
  SendGroupsto1.Enabled := bMoreSelected;
  SendGrouptoplanets1.Enabled := bOneSelected;
  mniUpgrade.Enabled := bMoreSelected;
  FindGroupinOrders1.Enabled := bOneSelected;
end;

procedure TfrmPlanets.Viewplanetscentered1Click(Sender: TObject);
begin
  Viewplanetscentered1.Checked := not Viewplanetscentered1.Checked;
end;

function ItemCompare(item1, item2: TListItem; SortColumn: integer): integer;
var
  tmpSingle1: Single;
  tmpSingle2: Single;
begin
  Result := 0;
    if Assigned(item1) and Assigned(Item2) and Assigned(item1.data) and
       Assigned(Item2.data) then begin
      case SortColumn of
        -1: if mkAtoI(item1.Caption) < mkAtoI(item2.Caption) then
              Result := -1
            else
              if mkAtoI(item1.Caption) > mkAtoI(item2.Caption) then
                Result := 1;
        0,2:
            if mkAtoI(item1.subItems[SortColumn]) < mkAtoI(item2.subItems[SortColumn]) then
              Result := -1
            else
              if mkAtoI(item1.subItems[SortColumn]) > mkAtoI(item2.subItems[SortColumn]) then
                Result := 1;
        1,3,12: Result := CompareText(item1.subItems[SortColumn], item2.subItems[SortColumn]);
      else
        try
          tmpSingle1 := StrToFloat(item1.subItems[SortColumn]);
        except
          tmpSingle1 := 0;
        end;
        try
          tmpSingle2 := StrToFloat(item2.subItems[SortColumn]);
        except
          tmpSingle2 := 0;
        end;
        if tmpSingle1 < tmpSingle2 then begin
          Result := -1
        end else begin
          if tmpSingle1 > tmpSingle2 then begin
            Result := 1;
          end;
        end;
      end;
    end;
end;

procedure MySort(items: TListItems; L, R: Integer; SortColumn: integer;
                 Ascending: boolean);
var
  I, J: Integer;
  listItem: TListItem;
  vComp: integer;
begin
  listItem := TListItem.Create(items);
  listItem.StateIndex := -1;
  try
    i := 0;
    while i < items.Count do begin
      if Assigned(items[i].Data) then begin
        j := items.Count -1;
        while j > i do begin
          if Assigned(items[j].Data) and Assigned(items[j-1].Data) then begin
            vComp := ItemCompare(items[j-1], items[j], SortColumn);
            if vComp <> 0 then begin
              if not Ascending then vComp := vComp * -1;
              if vComp > 0 then begin
                listItem.Assign(items[j-1]);
                items[j-1].Assign(items[j]);
                items[j].Assign(listItem);
              end;
            end;
          end;
          dec(j);
        end;
      end;
      inc(i);
    end;
  finally
    listItem.Free;
  end;
end;

procedure TfrmPlanets.DoGroupsSort(SortColumn: Integer;
  Ascending: boolean);
var
  tmpExtStyles: TLVExtendedStyles;
begin
  lvGroups.BeginUpdate;
  try
    tmpExtStyles := lvGroups.ExtendedStyles;
    MySort(lvGroups.Items, 0, lvGroups.items.count -1, SortColumn, Ascending);
    lvGroups.ExtendedStyles := tmpExtStyles;
  finally
    lvGroups.EndUpdate;
  end;
end;

procedure TfrmPlanets.lvGroupsColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if FGroupColumn <> Column.Index -1 then begin
    FGroupColumn := Column.Index -1;
    FGroupAscending := true;
  end else begin
    FGroupAscending := not FGroupAscending;
  end;
  DoGroupsSort(FGroupColumn, FGroupAscending);
end;

procedure TfrmPlanets.mniRandomNameClick(Sender: TObject);
begin
  if Assigned(CurrentPlanet) then begin
    CreateRandomName(CurrentPlanet);
  end;
end;

procedure TfrmPlanets.CreateRandomName(aCurrentPlanet: TPlanet);
var
  strNewPlanetName: string;
  vNameExists: boolean;
  stlRenameplanetsList: TStrings;
  i, index: integer;

  elite_planet: TGalaxy_Seed;
begin
  if Assigned(aCurrentPlanet) then begin
    stlRenameplanetsList := TStringList.Create;
    try
      frmOrders.FindRenameOrders(stlRenameplanetsList);
      i := 0;
      elite_planet := current_Galaxy;
      vNameExists := true;
      while (i < 10000) and vNameExists do begin
        strNewPlanetName := Planet_Name(elite_planet);
        Nextplanet(elite_planet);
        vNameExists := stlRenameplanetsList.IndexOf(strNewPlanetName) <> -1;
        if not vNameExists then
          for index := 0 to planets.Count - 1 do
            if (CompareText(strNewPlanetName, Planets[index]) = 0) and
              (Planets.objects[index] <> CurrentPlanet) then begin
              vNameExists := true;
              break;
            end;
        inc(i);
      end;
    finally
      stlRenameplanetsList.Free;
    end;
    if not vNameExists then
      frmOrders.InsertPlanetCommand('N ' + aCurrentPlanet.Name + ' ' + strNewPlanetName);
  end;
end;

procedure LvDataPlanetsAdd(listview: TmkListView;
                           curplanet: TPlanet);
var
  owner: string;
  SmallPlanetData: PSmallPlanetData;
begin
  curPlanet.SetLastOwner;
  case curPlanet.LastOwnerType of
    1: owner := curPlanet.LastOwnerName;
    2: if curPlanet.LastOwnerTurn > -1 then
        owner := format('?(%d) %s', [curPlanet.LastOwnerTurn, curPlanet.LastOwnerName])
      else
        owner := '?';
    3: owner := format('??(%d) %s', [curPlanet.LastOwnerTurn, curPlanet.LastOwnerName]);
  end;
  new(SmallPlanetData);
  SmallPlanetData.Name := curPlanet.Name;
  SmallPlanetData.Owner := owner;
  SmallPlanetData.Distance := Format('%4.2f', [curPlanet.Distance / 100]);
  SmallPlanetData.planet := curPlanet;
  listview.ViewList.Add(SmallPlanetData);
end;

procedure DoDataFillLvPlanets(listview: TmkListView;
                              FilterGroups, InverseGroups: boolean);
var
  i: integer;
  curPlanet: TPlanet;
  list: TList;
  SmallPlanetData: PSmallPlanetData;
begin
  if not Assigned(frmGroupFilter) then Exit;
  listview.Items.BeginUpdate;
  list := TList.Create;
  for i := 0 to listview.ViewList.Count -1 do begin
    SmallPlanetData := listview.ViewList[i];
    SmallPlanetData.Name := '';
    SmallPlanetData.Owner := '';
    SmallPlanetData.Distance := '';
    dispose(SmallPlanetData);
  end;
  listview.ViewList.Clear;
  listview.Items.Clear;
  try
    if FilterGroups then
    begin
      frmGroupFilter.GroupFilter.CalculateGroupsOnPlanet;
      for i := 0 to planets.count - 1 do
      begin
        curPlanet := TPlanet(Planets.Objects[i]);
        if frmExpressionFilters.Filteredplanets.IndexOf(curPlanet) = -1 then continue;
        if (not FilterGroups or (FilterGroups and ((frmGroupFilter.GroupFilter.GroupsOnPlanets.IndexOf(curPlanet) <> -1) xor InverseGroups))) then
          LvDataPlanetsAdd(listview, curplanet);
      end;
    end
    else
      for i := 0 to planets.count - 1 do
      begin
        curPlanet := TPlanet(Planets.Objects[i]);
        if frmExpressionFilters.Filteredplanets.IndexOf(curPlanet) = -1 then continue;
        LvDataPlanetsAdd(listview, curplanet);
      end;
  finally
    list.Free;
    listview.Items.Count := listview.ViewList.Count;
    listview.Items.EndUpdate;
  end;
end;

function DoSmallPlanetDataComp(Item1, Item2: Pointer;
                               SortDirection: TmkSortDirection;
                               aColumn: integer): Integer;
begin
  case aColumn of
    0: Result := CompareText(PSmallPlanetData(Item1).Name,
                             PSmallPlanetData(Item2).Name);
    1: begin
         if StrToFloat(PSmallPlanetData(Item1).Distance) <
            StrToFloat(PSmallPlanetData(Item2).Distance) then
           Result := -1
         else
           if StrToFloat(PSmallPlanetData(Item1).Distance) >
              StrToFloat(PSmallPlanetData(Item2).Distance) then
             Result := 1
           else
             Result := 0;
       end;
    2: Result := CompareText(PSmallPlanetData(Item1).Owner,
                             PSmallPlanetData(Item2).Owner);
  end;
  if SortDirection = sdDesc then
    Result := -Result;
end;

procedure DoSmallPlanetDataDoubleClick(listview: TmkListView;
                                       index: integer);
var
  i: integer;
  x0, y0: integer;
begin
  listview.Items.BeginUpdate;
  try
    if not (index < listview.Items.Count) or (index < 0) then Exit;
    x0 := PSmallPlanetData(listview.ViewList[index]).planet.x;
    y0 := PSmallPlanetData(listview.ViewList[index]).planet.y;
    for i := 0 to listview.Items.Count - 1 do
      PSmallPlanetData(listview.ViewList[i]).planet.SetDistanceFrom(x0, y0);
    for i := 0 to listview.Items.Count - 1 do
      PSmallPlanetData(listview.ViewList[i]).Distance := format('%3.2f', [PSmallPlanetData(ListView.ViewList[i]).planet.Distance / 100]);
  finally
    listview.Items.EndUpdate;
  end;
end;

function DoSmallPlanetDataShowPlanet(listview: Tmklistview; planet: TPlanet;
                                     SelectOne: boolean): integer;
var
  listItem: TListItem;
begin
  Result := 0;
  while Result < listview.ViewList.Count do begin
    if planet = PSmallPlanetData(listview.ViewList[Result]).planet then begin
      listItem := listview.Items[Result];
      if listItem = nil then Exit;
      if SelectOne and Assigned(listview.Selected) then
        listview.Selected.Selected := false;
      listItem.MakeVisible(False);
      if SelectOne then begin
        listview.Selected := listItem;
      end else
        listItem.Selected := not listItem.Selected;
      Exit;
    end;
    inc(Result);
  end;
  Result := -1;
end;

procedure TfrmPlanets.mkListView1Data(Sender: TObject; Item: TListItem);
begin
  Item.Caption := PSmallPlanetData(mkListView1.ViewList[Item.Index]).Name;
  Item.SubItems.Add(PSmallPlanetData(mkListView1.ViewList[Item.Index]).Distance);
  Item.SubItems.Add(PSmallPlanetData(mkListView1.ViewList[Item.Index]).Owner);
end;

procedure TfrmPlanets.mkListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  mkListview1.ViewList.SortColumn := Column.Index;
end;

procedure TfrmPlanets.mkListView1DblClick(Sender: TObject);
begin
  if Assigned(mkListView1.Selected) then
    DoSmallPlanetDataDoubleClick(mkListView1, mkListView1.Selected.Index);
end;

procedure TfrmPlanets.mkListView1Click(Sender: TObject);
var
  planet: Tplanet;
begin
  if Application.Terminated or not Assigned(mkListView1.Selected) then
    Exit;
  DoClick(mkListView1.Selected.Index);
  planet := PSmallPlanetData(mkListView1.ViewList[mkListView1.Selected.Index]).planet;
  if planet <> nil then
  begin
    if Assigned(frmNewMap) then
      frmNewMap.Pointplanet(planet, Viewplanetscentered1.Checked);
    frmShipDesign.SetBaseMassPlanet(planet);
  end;
end;

procedure OrdersDataDevPlanets(SelectedItems: TList; const aRecordType: integer);
var
  i: integer;
  strText: string;
  planetName: string;
begin
  strText := '';
  for i := 0 to SelectedItems.Count - 1 do begin
    if strText <> '' then strText := strtext + #13#10;
    case aRecordType of
      1: planetName := PSmallPlanetData(SelectedItems[i]).Name;
      2: planetName := PBigPlanetData(SelectedItems[i]).Name;
    end;
    strText := strText + ';P ' + planetName;
  end;
  frmOrders.InsertPlanetCommand(strText);
end;

procedure OrdersDataClaimPlanets(SelectedItems: TList; const aRecordType: integer);
var
  i: integer;
  strText: string;
  planetName: string;
begin
  strText := '';
  for i := 0 to SelectedItems.Count - 1 do begin
    if strText <> '' then strText := strtext + #13#10;
    case aRecordType of
      1: planetName := PSmallPlanetData(SelectedItems[i]).Name;
      2: planetName := PBigPlanetData(SelectedItems[i]).Name;
    end;
    strText := strText + 'V ' + planetName;
  end;
  frmOrders.InsertPlanetCommand(strText);
end;

procedure OrdersDataProduceOnPlanets(SelectedItems: TList; const aRecordType: integer);
const
  strProduce: string = '';
var
  i: integer;
  strText: string;
  planetName: string;
begin
  strText := '';
  if GetProduceItem(strProduce) then begin
    for i := 0 to SelectedItems.Count - 1 do begin
      if strText <> '' then strText := strtext + #13#10;
      case aRecordType of
        1: planetName := PSmallPlanetData(SelectedItems[i]).Name;
        2: planetName := PBigPlanetData(SelectedItems[i]).Name;
      end;
      strText := strText + 'P ' + planetName + ' ' + strProduce;
    end;
    frmOrders.InsertPlanetCommand(strText);
  end;
end;

procedure TfrmPlanets.FormDestroy(Sender: TObject);
begin
  FExportMkListView.Free;
end;

procedure TfrmPlanets.FormActivate(Sender: TObject);
{var
  i: integer;}
begin
  FOldIdleEvent := Application.OnIdle;
  Application.OnIdle := DoOnIdle;
  mkListView1.DeselectAll;
{  for i := 0 to mkListView1.Items.Count -1 do begin
    mkListView1.Items[i].Selected := false;
  end;}
  if (FLastIndex <> -1) and (FLastIndex < mkListView1.items.count) then begin
    mkListView1.Selected := mkListView1.Items[FLastIndex];
    mkListView1.Selected.MakeVisible(False);
  end;
end;

procedure TfrmPlanets.FormDeactivate(Sender: TObject);
begin
  Application.OnIdle := FOldIdleEvent;
end;

procedure TfrmPlanets.DoOnIdle(Sender: TObject; var Done: boolean);
begin
  if not Assigned(frmNewMap) then Exit;
  if frmNewMap.DoNotpointPlanet then Exit;
  if Assigned(mkListview1.selected) then begin
    if FLastIndex <> mkListview1.selected.Index then begin
      DoClick(mkListview1.selected.Index);
      frmNewMap.Pointplanet(PSmallPlanetData(mkListView1.ViewList[FLastIndex]).planet,
                            Viewplanetscentered1.Checked);
    end;
  end;
end;

procedure TfrmPlanets.Unload1Click(Sender: TObject);
var
  group: TGroup;
  i: integer;
  list: TStrings;
  orders: string;
begin
  list := TStringlist.Create;
  try
    for i := 0 to lvGroups.Items.Count - 1 do
      if lvGroups.Items[i].selected then
        if lvGroups.Items[i].data <> nil then
        begin
          group := TGroup(lvGroups.Items[i].data);
          if (group.Player = qreportPlayer) and (group.Lading > 0) then
            list.Add(IntToStr(group.Nr));
        end;
    if list.Count > 0 then
    begin
      for i := 0 to list.Count - 2 do
        orders := orders + 'U ' + list.Strings[i] + #13#10;
      orders := orders + 'U ' + list.Strings[list.Count - 1];
      frmOrders.InsertCommand(orders);
      frmOrders.AnalyseAndDoOutput;
    end;
  finally
    list.free;
  end;
end;

end.

